#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <zephyr/types.h>
#include <ctype.h>
#include "common.h"

// random commment

extern struct EEPROMMAP MAP;

uint32_t chk_cert(int nbr)                                               // calculate the Quectel cksum for a cert file
                                                                         // nbr 0 is cacert, nbr 1 is clicert, nbr 2 is clikey
                                                                         // nbr 3 is endpoint
{
    uint32_t j,eeprom_addr,read,left,lth;
    uint32_t cksum;
    uint8_t buffer[150];
    eeprom_addr=MAP.addr[nbr*2+1];
    left=MAP.addr[nbr*2+2];
    read=0;
    cksum=0;
    while(left>0)                                               // cksum is the sum ov the bytes in the certificate
    {
        if(left>128)
            lth=128;
        else lth=left;
        eeprom_retrieve(eeprom_addr,lth,buffer);
        for(j=0;j<lth;j++)
            cksum+=buffer[j];
        read+=lth;
        left-=lth;
        eeprom_addr+=lth;
     }
     return cksum;
  
}
void dump_cert(uint32_t cert)
{
    uint32_t eeprom_addr,read,left,lth;
    uint16_t cksum;
    uint8_t buffer[150],msg[82];
    eeprom_addr=MAP.addr[cert*2+1];
    left=MAP.addr[cert*2+2];
    read=0;
    cksum=0;
    while(left>0)                                               // cksum is the 16 bit result of XORING pairs of chatacters together
    {
        if(left>80)
            lth=80;
        else lth=left;
        eeprom_retrieve(eeprom_addr,lth,buffer);
        memset(msg,0,sizeof(msg));
        memmove(msg,buffer,lth);
        bt_send_data(msg);
        read+=lth;
        left-=lth;
        eeprom_addr+=lth;
    }


}


