/*
 * DATE.C - DATE CONVERTION ROUTINES
 *  
 *      Author: kover
 */
#include <zephyr/kernel.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <zephyr/types.h>
#include <ctype.h>
#include "common.h"
#define SECSYR 31536000                             // seconds per year       
#define SECSLPYR  31622400                          // seconds per leap year 
#define SECSDAY   86400                             // seconds in a day  
uint8_t monthdays[] = {31,28,31,30,31,30,31,31,30,31,30,31};                  
  



struct RTCDATE dt_to_disp(uint32_t posixtime)
{struct RTCDATE dt;
 uint32_t i,j;
 uint32_t ysecs;
 uint32_t posix;
 uint32_t year=1970;
 uint32_t month=0;
 uint32_t day=0;
 uint32_t hour=0;
 uint32_t minute=0;
 uint32_t second=0;
 posix=posixtime;                                                // retrieve the argument
 
 while(1)                                                        // loop through yeas
     {i=year%4;                                                  // see if the working year is a leap year
      if(i==0)
         ysecs=SECSLPYR;
      else ysecs=SECSYR;
      if(posix>ysecs)                                            // if the remaining seconds exted beyond the end of the current year
        {posix=posix-ysecs;                                      // reduce the seconds
         year++;                                                 // increment the year
         continue;                                               // and loopo
        }
      break;                                                     // otherwise we're done
     }
 i=year%4;                                                       // the same leap year test
 if(i==0)
   monthdays[1]=29;                                             // this time to see if the curent year is a leap year
 else monthdays[1]=28;
 month=1;
 for(i=0;i<12;i++)                                              // now loop through the months
    {j=monthdays[i]*SECSDAY;                                    // calculate secinds in the current month
     if(j>=posix)                                               // iuf we're in the current month
        break;                                                  //   we're done 
     posix=posix-j;                                             // otherwise, we reduce posix
     month++;                                                   // and increment the month
    }
 day=(posix/SECSDAY)+1;                                         // calculate the day of the month
 posix=posix%SECSDAY;                                           // what's left is the time
 hour=posix/3600;
 posix=posix%3600;
 minute=posix/60;
 second=posix%60;
 dt.year=year;
 dt.month=month;
 dt.day=day;
 dt.hour=hour;
 dt.minute=minute;
 dt.second=second;
 return dt;
}
uint32_t dt_to_posix(struct RTCDATE dispdate)
{
 uint32_t i;
 uint32_t ysecs;
 uint32_t posix=0;
 uint32_t year=1970;
 uint32_t month=1;

 while(1)                                                        // loop through yeas
     {if(year==dispdate.year)                                    // if we've made it to this year
         break;                                                  // we're done
      i=year%4;                                                  // see if the working year is a leap year
      if(i==0)
        ysecs=SECSLPYR;
      else ysecs=SECSYR;
      posix=posix+ysecs; 
      year++;                                           
     }
 i=year%4;                                                       // the same leap year test
 if(i==0)                                                        // this time to see if the curent year is a leap year
   monthdays[1]=29;
 else monthdays[1]=28;
 month=1;
 for(i=0;i<12;i++)                                              // now loop through the months
    {if(month==dispdate.month)                                  // if we're at the currrent month
         break;                                                 //     we're done
     posix=posix+monthdays[i]*SECSDAY;
     month++;
    }
 posix=posix+(dispdate.day-1)*SECSDAY;
 posix=posix+dispdate.hour*3600;
 posix=posix+dispdate.minute*60;
 posix=posix+dispdate.second;
 return posix;
}