

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <zephyr/kernel.h>
//#include <zephyr.h>
#include <zephyr/device.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/sys/reboot.h>
#include <dfu/dfu_target.h>
#include <dfu/dfu_target_mcuboot.h>
#include <zephyr/storage/flash_map.h>
#include <zephyr/drivers/flash.h>
#define SECONDARY_SLOT_ID FLASH_AREA_ID(image_1)

#include "common.h"
void erase_secondary_slot1(void)
{
    const struct flash_area *fa;
    uint8_t buffer[100];
    int err = flash_area_open(SECONDARY_SLOT_ID, &fa);
    if (!err) {
        bt_send_data("Erasing secondary firmware slot...");
        sprintf(buffer,"OFFSET=%x SZ=%x",fa->fa_off,fa->fa_size);
        bt_send_data(buffer);
        err = flash_area_erase(fa, 0, fa->fa_size);
        if (err) {
            sprintf(buffer,"Failed to erase secondary slot (err %d)", err);
            bt_send_data(buffer);
        } else {
            bt_send_data("Secondary slot erased successfully!");
        }
        flash_area_close(fa);
    } else {
      sprintf(buffer,"Failed to open secondary slot (err %d)", err);
      bt_send_data(buffer);
    }
}
    
void que_fw_download1()
{
    uint8_t buffer[1200],buffer2[1200],buffer3[100];
    uint8_t hexchars[]="0123456789ABCDEF";
    uint8_t hexchar1,hexchar2,hexchar3,hexchar4,hexchar5;
    int32_t cksumgiven, cksum, filesize, bytesleft,xblocknbr,xblocksize,xchksum,blocknbr,ychksum,i,j,k;
    uint8_t fwblock[1024]="3DB8F3960000000000020000589403000000000000000000\
 0000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFF";
    
   bytesleft=235247;
   filesize=235247;
   cksumgiven=24413039;
   sprintf(buffer3,"BLOCK ID %d LONG",sizeof(fwblock));
   blocknbr=0;

        xblocknbr=0;                                        // get the block params
        xblocksize=512;
        xchksum=12327;
        ychksum=0;                                                                  // set the calculated block checksum to 0
        memset(buffer,0,sizeof(buffer));                                           // clear the buffer to NULLs
        memset(buffer3,0,sizeof(buffer3));
        memmove(buffer,fwblock,1024);
        memset(buffer2,0,sizeof(buffer2));                                         // clear the target to NULLS
        if(bytesleft>512)                                                           // calculate the umber of bytes to be decoded
             k=512;
        else k=bytesleft;
        hexchar3='0';
        hexchar4='0';
        for(i=0;i<k;i++)                                                          // now - scan the encoded hex data
        {
         hexchar1=buffer[i*2];                                                     // get a pair of hex characters
         hexchar2=buffer[i*2+1];
         for(j=0;j<16;j++)                                                         // translate each character to it's hex equivalent
             {
               if(hexchars[j]==hexchar1)
               {
                  hexchar3=j;
                  break;
               }
             } 
             for(j=0;j<16;j++)                                                         // translate each character to it's hex equivalent
             {
               if(hexchars[j]==hexchar2)
               {
                  hexchar4=j;
                  break;
               }
             }

         hexchar5=hexchar3<<4;
         hexchar5+=hexchar4;                                                            // assemble the target hes character
         buffer2[i]=hexchar5;                                                           // put it in the buffer


        cksum+=hexchar5;                                                                // and add it to the cksum
        ychksum+=hexchar5;
        }   
       
        sprintf(buffer,"%02X%02X%02X%02X%02x%02X cksum %d left %d block=%d size=%d sum=%d xsum=%d",buffer2[0],buffer2[1],buffer2[2],buffer2[3],buffer2[4],buffer2[5],cksum,bytesleft,
                          xblocknbr,xblocksize,xchksum,ychksum);
        bt_send_data(buffer);
        /*
        if((xchksum!=ychksum)||(xblocknbr!=blocknbr))                                   // if this block is in error
        {

               cksum-=ychksum;                                                         // take away the checksum that is in error
               bt_send_data("BAD BLOCK BAD BLOCK BAD BLOCK BAD BLOCK");                // put a message in the output data stream (so I can find it in the data dump)
               return;                                          // and go retry
        }
               */
        bytesleft=bytesleft-k;  
        if(xblocknbr==0)                                                                 // if this is block 0
        {
         i=dfu_target_img_type	(	buffer2,xblocksize);                              // go figure outimage type
         sprintf(buffer,"DFU TYPE IS %d",i);
         bt_send_data(buffer);
         erase_secondary_slot1();
         i=dfu_target_reset();
         sprintf(buffer,"TARGET RESET RETURNED %d",i);
         bt_send_data(buffer);
         i=dfu_target_init(DFU_TARGET_IMAGE_TYPE_MCUBOOT,0,filesize,NULL);
         
         sprintf(buffer,"TARGET INIT RETURNED %d",i);
         bt_send_data(buffer);
        }
        blocknbr++;                                                                // increment the block numbe                                               
}

