/*stt
 * Copyright (c) 2017 comsuisse AGFrftestF
 *
 * SPDX-License-Identifier: Apache-2.0FF
 */



#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <zephyr/kernel.h>
//#include <zephyr.h>
#include <zephyr/device.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/sys/reboot.h>
#include <dfu/dfu_target.h>
#include <dfu/dfu_target_mcuboot.h>
#include <zephyr/storage/flash_map.h>
#include <zephyr/drivers/flash.h>

#include "common.h"
#define STACKSIZE 4096
#define PRIORITY 7
extern uint8_t CMD[]; 
extern uint8_t RFIDTAGID[];
extern struct device *gpio0;
extern struct device *gpio1;
extern struct k_sem ble_init_ok;
extern struct k_sem run_script;
extern struct k_timer msclock;
extern struct k_fifo(fifo_cmd_data);
extern uint8_t FWVERSION[];
extern uint16_t IDLEVOLTAGE;
extern uint32_t KEYPAD_IDLE_LIMIT;                                             // Used to deterine keypad idle timeout
extern uint32_t MTRMODE;                                                       // motor operating mode - 1 = single phase, 2 = two phase
volatile extern int MILLITIME;
extern uint32_t QMSGCNT; 
extern bool TIMER_RUNNING;
extern struct k_mutex quelock;
extern struct k_timer alarm;
extern bool KEYPAD_TIMED_OUT;
extern bool DOORCLOSED;
extern bool RUN_CHECK_SWS;
extern bool RUN_SPOOF;
extern volatile bool NO_BT_DISP;
extern  bool PROCRUNNING; 
extern bool QPOWEREDUP;
extern bool QCONNECTED;
extern bool CONNECTED;
extern bool SUPERUSERMODE;
extern bool LOGGING;
extern bool ALARM;
extern bool VDD2_UP;
extern uint32_t FLASHER_MODE;                                                    // 1 IS FOR QUECTEL - FLSH RED/GREEN AT 1/2 SECIND 
extern struct k_timer flasher;                                                     // for flashing red aand green leds durig quectel activity
extern struct k_timer check_sws;
extern struct k_timer spoof;
extern bool PATTERNFOUND;
extern uint8_t PATTERNREC[];
extern uint8_t PREVREC[];
extern uint8_t PATTERN[];
extern bool DOORACTIVE;
extern bool RUNNINGSCRIPT;
extern bool SCRIPTPAUSE;
extern uint8_t SCRIPTCMD1[];
extern uint8_t SCRIPTCMD2[];
extern int32_t SCRIPTCNT;
extern bool SCRIPTCMDDONE;
extern uint16_t VTBL[];                                                            // voltages tabled by the voltage monitoring task
extern k_tid_t CURRENT_THREAD;
extern uint32_t TIMEOUTDELAY;                                       // set by lockcmd.c, it is used to set the open_alarm and tag_alarmtimers

 uint8_t AWSPARAMS[20];
 uint32_t AWSSIZE;
 uint32_t AWSCKSUM;
 uint32_t AWSTYPE;
 uint16_t LOW_VOLTAGE;                                                           // the lowest battery voltage seen while the motor is spinning
 uint32_t LVCNT=0;
 bool AWSLOADING=false;
 extern struct EEPROMMAP MAP;
 //extern volatile bool UART_DATA_RECD;

uint32_t EEPROM_ADDR=0;
uint32_t EEPROM_SIZE=0;
extern bool RUNNING;
extern bool TESTING;
extern struct PARAMS PARMS;

K_SEM_DEFINE(voltage_mon_on,0,10);
K_SEM_DEFINE(voltage_mon_off,0,10);
extern struct k_fifo uart_data; 
#define SECONDARY_SLOT_ID FLASH_AREA_ID(image_1)

void dump_voltages()
{
   uint8_t buff1[100], buff2[20];
   uint32_t i,j,k,lvlmax;
   uint16_t volts;
   i=0;
   memset(buff1,0,sizeof(buff1));
   if(LVCNT>2998)
       lvlmax=2998;
   else lvlmax=LVCNT;
   while(i<lvlmax)
   {
     volts=VTBL[i];
     j=volts/1000;
     k=volts%1000;
     sprintf(buff2,"%d.%03d ",j,k);
     strcat(buff1,buff2);
     if(strlen(buff1)>50)
     {
      strcat(buff1,",");
      bt_send_data(buff1);
      k_sleep(K_MSEC(100));
      memset(buff1,0,sizeof(buff1));
     }
     i++;
   }
   if(strlen(buff1)>0)
   {
      strcat(buff1,",");
       bt_send_data(buff1);
   }
}
void script_task()                                                                   // this routine runs scripts
{                                                                                    // note that it is a seperate task
   int32_t cycle, cycles_left,i;
   uint8_t buffer[20];
   while(true)
   {
      k_sem_take(&run_script,K_FOREVER);                                             // wait until the semaphore comes up
      cycles_left=SCRIPTCNT*2;                                                       // set up the number of cycles to run
      cycle=0;                                                                       // and the cycle we're running
      if(!SCRIPTPAUSE)                                                               // if we are running wirhut pausing for operator intervention
      {
          TESTING=true;                                                              // set the TESTING switch (lockcmd will run 123456 and 654321)
          k_sleep(K_MSEC(10000));                                                     // sleep for 10 seconds - this allows time for a disconnect
      }      
      while(true)                                                                    // now - start executing commands
      {
         sprintf(buffer,"SRIPT CYCLE %d",cycle+1);
         bt_send_data(buffer);
         i=cycle%2;                                                                  // see iff we're running cmd1 or cmd2
         if(i==0)                                                                    // and set it up
             sprintf(buffer,"CMD%s",SCRIPTCMD1);
         else sprintf(buffer,"CMD%s",SCRIPTCMD2);
         SCRIPTCMDDONE=false;                                                        // we need to know when the command is done
         strcpy(CMD,buffer);                                                         // copy the formatted commaand to the command buffer
         if(!VDD2_UP)                                                                // if vdd2 isn't up
         {
             vdd2_up();                                                              // bring it up
             gpio_pin_set(gpio0,LED_ILLUM,0);                                        //  turn off the ILLUMINATION LEDs
         }
         lockcmd();                                                                  // and run it
         while(true)                                                                 // now - wait fr it to complete
         {
            k_sleep(K_MSEC(200));                                                    // loo every 2000 msec
            if(SCRIPTCMDDONE)                                                        // if thw command has completed
                 break;                                                              // move ahead
         }
         if(!SCRIPTPAUSE)                                                            // if we're rrunning withot a pause
             k_sleep(K_MSEC(120000));                                                //      wait for the the QUPDATE to run
         cycle++;                                                                    // add 1 to cycle number
         cycles_left--;                                                              // subtract 1 from cycles to run
         if(cycles_left>0)                                                           // if we've got more to go
               continue;                                                             //     loop
         RUNNINGSCRIPT=false;                                                        // otherwise, we're done - let the calling routine know
         TESTING=false;                                                              // turn off the TESTING Switch (we may have turned it on)
         break;                                                                      // and get out of the script loop
      } 
                                                                                     // this is the bottom of the script loop - fromm here we go back to the k_sem_take
   }

}
K_THREAD_DEFINE(script_task_id, STACKSIZE, script_task, NULL, NULL,
		NULL, PRIORITY, 0, 0);
void script()
{  int32_t count,xcnt;
   uint8_t buffer[100],buffer2[100];
   bool pause;
   int32_t cmd;
   int32_t err;
   int32_t i;
   err=0;
   if(CMD[26]==',')                                                                    // elimiinate the trailing comma
      CMD[26]=0;
   if(CMD[12]!=';')                                                                    // edit the comand  - checking the semicolons
      err=1;        
   if(CMD[19]!=';')                                                                  
      err=1; 
   if(CMD[24]!=';')                                                                    
      err=1;  
   if(err==0)
     if((CMD[25]!='Y')  &&(CMD[25]!='N'))   
        err=2;                         
   if(err==0)
      if(CMD[26]!=0)                                                                   // there ust be a NULL here
         err=3; 
   
   if(err==0)
      for(i=6;i<12;i++)                                                                // check that the fields are numeric  
         if((CMD[i]<'0')||(CMD[i]>'9'))
           err=4;   
   if(err==0)
      for(i=13;i<19;i++)                                                               // check that the fields are numeric  
         if((CMD[i]<'0')||(CMD[i]>'9'))
              err=4;    
   if(err==0)         
      for(i=21;i<24;i++)                                                               // check that the fields are numeric  
         if((CMD[i]<'0')||(CMD[i]>'9'))
           err=4;
   if(err==0)                                                                          // if there are n errors yer
   {   CMD[24]=0;                                                                      // terminate the count with a NULL
       count=atoi(&CMD[20]);                                                           // convert it to an integer
       if((count<1)||(count>3000))                                                      //    and make sure it's in range 1 to 3000
          err=5;
   }                          
   if(err!=0)                                                                          //  if there is an error
      {
         sprintf(buffer,"ERR %d",err);                                                 // report it
         bt_send_data(buffer);
         return;                                                                       // and get out
      }
   memset(SCRIPTCMD1,0,10);                                                            // put the comands inti global storage for the scrpt taask to use_sem
   memset(SCRIPTCMD2,0,10);
   memmove(SCRIPTCMD1,&CMD[6],6);
   memmove(SCRIPTCMD2,&CMD[13],6);
   if(CMD[25]=='Y')                                                                    // set the pause variable
       SCRIPTPAUSE=true;
   else SCRIPTPAUSE=false;
   SCRIPTCNT=count;
   sprintf(buffer,"RUN %s then %s %d TIMES ",SCRIPTCMD1,SCRIPTCMD2,SCRIPTCNT);
   if(SCRIPTPAUSE)
       strcat(buffer,"PAUSING FOR OPERATOR");
   else strcat(buffer,"WITH NO PAUSES");
   bt_send_data(buffer);
   RUNNINGSCRIPT=true;                                                                // et the RUNNINGSCRIPT FLAG
   k_sem_give(&run_script);                                                           // and fire off the task
   while(true)                                                                        // now ... loop
   {
      k_sleep(K_MSEC(1000));                                                          // checkcng the RUNNING SCRIPT logical
      if(!RUNNINGSCRIPT)                                                              // once a second until it toggles off
           break;                                                                     //      then return
   }


}
void load_imei()                                                                       // load the IMEI number from the SIM card into the PARAMS record
{
   int32_t ret;
   uint8_t buffer[100];
   if(QPOWEREDUP)                                                                      // if the module is powered up - something is wrong                                     
   {
        bt_send_data("MODULE IS ALREADY POWERED UP");                                  // send a message
        quectel_powerdown() ;                                                          // power it down
        return;                                                                        // and get out
   }


   ret= quectel_powerup();                                                             // power uo the module
   if(!QPOWEREDUP)                                                                     // if there was a failure
   {
      bt_send_data("POWER UP FAILURE");                                                // send a message
      return;                                                                          // and get out
   }

      strcpy(PATTERN,"OK");                                                            // tell the message received thread what to look for
      ALARM=false;                                                                     // turn off the ALARM
      PATTERNFOUND=false;                                                              //   and reset the PATTERNFOUND flag
      k_timer_start(&alarm,K_MSEC(1000),K_NO_WAIT);                                    // set the alarm clock to 1 seconds
	   qmsgsend("AT+CIMI");                                                             // and send the command to the Quectel module
	   while((!ALARM)&&(!PATTERNFOUND))                                                 // now wait for either the pattern to be recevied or the alarm to go off
	   {
             k_sleep(K_MSEC(50)); 
      }
	   if(ALARM) 
	   {                                                                                // if the alarm went off
		    bt_send_data("NO SIM");                                                      // inform the user
          quectel_powerdown() ;                                                        // power down the module
          return;                                                                      // and get out

      }
  
      memset(PARMS.IMEI,0,sizeof(PARMS.IMEI));                                         // clear the PARMS field
      memmove(PARMS.IMEI,PREVREC,15);                                                  // move in the IMEI number      
      quectel_powerdown();                                                             // power down the mudule  module
      eeprom_update_parms();                                                           // update to the EEPROM
      sprintf(buffer,"OK (%s)",PARMS.IMEI);                                              // note that th IMEI number is embdded in the "OK"
      bt_send_data(buffer);                                                            // this is so PCBTEST can capture the IMEI number


}
void set_imei()
{
   int32_t i ,errsw; 
   if(PARMS.USEAWS!='Y')                                                             // if we're not using AWS
   {
      memset(PARMS.IMEI,0,sizeof(PARMS.IMEI));
      strcpy(PARMS.IMEI,"NONE");
      bt_send_data("SET TO NONE");                                                         // recect wuth an error
      return;
   }
   errsw=0;
   for(i=7;i<22;i++)                                                                  // IMEI is fifteen digits
   {
      if((CMD[i]<'0')||(CMD[i]>'9'))                                                  // if there's a non-digit
          errsw=1;                                                                    //    set a flag
   }
   if(errsw!=0)                                                                       //  if the flag was set
   {
      bt_send_data("ERR 2");                                                           // reject
      return;
   }
   memcpy(PARMS.IMEI,&CMD[7],15);                                                     // otherwise = update the PARAMS  
   eeprom_update_parms();                                                             //    and save them     
   bt_send_data("OK");                                
}
void set_motor()                                                            // set motor to single ohase or dual phase
{
   uint8_t cmd;
   cmd=CMD[8];                                                             // get the seting
   if((cmd!='1')&&(cmd!='2'))                                              // if it isn't 1 or 2
   {
      bt_send_data("ERR1");
      return;                                                               // reject it
   }
   if(cmd=='1')                                                             // otherwise - set the PARMS field
   {
      PARMS.MOTORMODE='1'; 
      bt_send_data("MOTOR SINGLE PHASE");
   }
   else {
          PARMS.MOTORMODE='2';
          bt_send_data("MOTOR DUAL PHASE");
        }
   eeprom_update_parms();                                                             //    and save PARMS  
}
void kbdtest()
{
 uint8_t testchar, keypaddata[10];
 uint32_t i;
 i=strlen(CMD);
 if(i!=8)                                                                              // if the command is not the correct length
    {bt_send_data("ERR 1");                                                            // return the error
     return;
    }
 testchar=CMD[6];                                                                      // save the character to be entered
 if(testchar=='#')                                                                     // if we got a # 
    testchar=',';                                                                      //      we'll test for  comma - commas can't be sent over the 
                                                                                       //      bluetooth coonnection
 keypadsetup();                                                                        // set up the keypad for one character to be returned
 memset(keypaddata,0,sizeof(keypaddata));                                              // clear the buffer
 KEYPAD_IDLE_LIMIT=MILLITIME+1000*PARMS.INATMO;                                       // set the keypad idle timeout
 KEYPAD_TIMED_OUT=false;  
 while(true)
 {
 strcpy(keypaddata, keypadgetchar());                                                  // go get one character from  the keypad
 if(strlen(keypaddata)!=0)
     break;
 }
 setup_keyscan();                                                                      // restore the keypad to initial state
 if(strlen(keypaddata)!=1)                                                            // if we didn't get exactly 1 character
 {
   bt_send_data("FAIL");                                                               // report failure
   return;
 }
 if(keypaddata[0]!=testchar)                                                           // if we didn't get the character we were lookinng for
 {
   bt_send_data("FAIL");                                                               // report failure
   return;
 }

 bt_send_data("OK");                                                                   // otherwise report success
}
void que_stat()
{ uint8_t ret;
  uint8_t buffer[40];
  if(QPOWEREDUP)
     bt_send_data("POWERED UP");
   else bt_send_data("POWRED DOWN");
   if(QCONNECTED)
       bt_send_data("ONNECTED");
   else bt_send_data("NOT CONNECTED");
}
void quec_up()
{
uint32_t ret;

ret=quectel_powerup();
if(ret==0)
   bt_send_data("OK");
else bt_send_data("FAILED");

}

void quec_down()
{
  uint32_t ret;
  ret=quectel_powerdown();
  if(ret==1)
  {
      bt_send_data("NOT POWERED UP");
      return;
  }
  if(ret==2)
  {
      bt_send_data("DIDN'T POWER DOWN");
      return;
  }
   
   
  bt_send_data("OK");
}
void commission_lockbox()                                                          // commission the lockbox
{uint32_t i;
 uint8_t crkey[11],lockid[13],buff[50];                                                     // the data must be exactly "CL" +  8 character lockboxx id
 bool err=false;                                                                   //         +a 8 character crypto key +  "#"
 if(strlen(CMD)!=26)
    {bt_send_data("ERR 1");
     return;
    }
 memset(crkey,0,sizeof(crkey));                                                     // sero out the work areas
 memset(lockid,0,sizeof(lockid));
 memmove(lockid,&CMD[7],10);                                                   // retrieve the lockbox id
 memmove(crkey,&CMD[17],8);
 for(i=0;i<10;i++)                                                                 // edit the lock id
    {if(lockid[i]<48)                                                             //    which must consist of onky the digits '0' thru '9'
       err=true;
     else if(lockid[i]<58)      
       break;
     if(lockid[i]<65)                                                              // and the letters 'A' thru 'Z'
       err=true;
     if(lockid[i]>90)
       err=true;
    }
 if(err)
    {bt_send_data("ERR 2");
     return;
    }
 for(i=0;i<8;i++)
    if(!(isprint(crkey[i])))
       {bt_send_data("ERR 3");
        return;
       }
        for(i=0;i<8;i++)
    if(crkey[i]==' ')
       {bt_send_data("ERR 3");
        return;
       }
 memmove(PARMS.lockid,lockid,10);                                                  // store the new values in params
 memmove(PARMS.crkey,crkey,8);
 PARMS.commdt=dt_to_posix(get_rtc());
 if(!LOGGING)
     logmsg_add(2,"COMMISSIONED");
 eeprom_update_parms();                                                               // and go update the eeprom copy of params
 
 bt_send_data("OK");
}
void setassy()
{
   TESTING=true;
   bt_send_data("OK");
}

void doortest()                                                                  // wait for the door switch to close
{
   
int32_t i=0,start,now,elapsed;
MILLITIME=0;                                                                     // reset the millisecond timer
TIMER_RUNNING=true;                                                              // set thr timer running flag                        
k_timer_start(&msclock, K_MSEC(1), K_MSEC(1));                                   // and start it up
start=MILLITIME;                                                                 // get the start time
  while(true)                                                                    // loop
  {

     i=gpio_pin_get(gpio0,DOORSW);                                               // read the switch
     if(i>0)                                                                     // if it's closed
         break;                                                                  //       exit the loop
     now=MILLITIME;                                                              // if ten seconds have passed
     elapsed=now-start;                                                        
     if(elapsed>10000)
     {
        TIMER_RUNNING=false;
        k_timer_stop(&msclock);                                                  // stop the milisecond timer
        bt_send_data("FAIL");                                                    // the switch never closed - report failure 
        return;                                                                  //     and get out
     }

  }
  k_timer_stop(&msclock);                                                        // stop the milisecond timer
  TIMER_RUNNING=false;                                                           // reset the flag
  bt_send_data("OK");                                                            // report success
}

void hasptest()                                                                  // wait for the hasp switch to close
{
int32_t i=0,start,now,elapsed;
MILLITIME=0;              
TIMER_RUNNING=true;                                                              // reset the millisecond timer
k_timer_start(&msclock, K_MSEC(1), K_MSEC(1));                                   // and start it up
start=MILLITIME;                                                                 // get the start time
  while(true)                                                                    // loop
  {
     i=gpio_pin_get(gpio0,HASPSW);                                               // read the switch
     if(i>0)                                                                     // if it's closed
         break;                                                                  //       exit the loop
     now=MILLITIME;                                                              // if ten seconds have passed
     elapsed=now-start;                                                        
     if(elapsed>10000)
     {
        TIMER_RUNNING=false;
        k_timer_stop(&msclock);                                                  // stop the milisecond ti
        bt_send_data("FAIL");                                                    // the switch never closed - report failure 
        return;                                                                  //     and get out
     }

  }
  k_timer_stop(&msclock);                                                        // stop the milisecond timer
  TIMER_RUNNING=false;
  bt_send_data("OK");                                                            // report success
}
void display_anchors()
{uint8_t msg[30];
 if(strlen(CMD)!=8)
   {bt_send_data("ERR 1");
    return;
   }
 struct EEPROMMSGS anchor;
 eeprom_retrieve(MAP.addr[11], sizeof(anchor), &anchor);
 sprintf(msg,"FSTHST  %d",anchor.fstmsg);
 bt_send_data(msg);
 sprintf(msg,"LSTHST  %d",anchor.lstmsg);
 bt_send_data(msg);
 sprintf(msg,"HSTCNT  %d",anchor.msgcnt);
 bt_send_data(msg);//k_sleep(K_MSEC(500));
 sprintf(msg,"HSTAVL  %d",anchor.availcnt-anchor.msgcnt);
 bt_send_data(msg);
 eeprom_retrieve(MAP.addr[10], sizeof(anchor), &anchor);
 sprintf(msg,"FSTDIAG  %d",anchor.fstmsg);
 bt_send_data(msg);
 sprintf(msg,"LSTDIAG  %d",anchor.lstmsg);
 bt_send_data(msg);
 sprintf(msg,"DIAGCNT  %d",anchor.msgcnt);
 bt_send_data(msg);
 sprintf(msg,"DIAGAVL  %d",anchor.availcnt-anchor.msgcnt);
 bt_send_data(msg);
 eeprom_retrieve(MAP.addr[12], sizeof(anchor), &anchor);
 sprintf(msg,"FSTMSG  %d",anchor.fstmsg);
 bt_send_data(msg);
 sprintf(msg,"LSTMSG  %d",anchor.lstmsg);
 bt_send_data(msg);
 sprintf(msg,"MSGCNT  %d",anchor.msgcnt);
 bt_send_data(msg);;
 sprintf(msg,"MSGAVL  %d",anchor.availcnt-anchor.msgcnt);
 bt_send_data(msg);
 bt_send_data("OK");
 }


void test_led()                                                                   // test the keypad LED
{uint8_t arg, state;
uint32_t  i;
 i=strlen(CMD);
 if(i!=10)
    {bt_send_data("ERR 1");
     return;
    }
 arg=CMD[7];
 state=CMD[8];
 if((arg!='r')&&(arg!='R')&&(arg!='g')&&(arg!='G')&&(arg!='i')&&(arg!='I'))       // test for a valid value
    {bt_send_data("ERR 2");
     return;
    }
 if((state!='0')&&(state!='1'))
    {
      bt_send_data("ERR 3");
      return;
    }
 if((arg=='g')||(arg=='G'))
    {if(state=='1')
         gpio_pin_set(gpio0,LED_GREEN,1);
    if(state=='0')
         gpio_pin_set(gpio0,LED_GREEN,0);
   }
 if((arg=='r')||(arg=='R'))
    {if(state=='1')
         gpio_pin_set(gpio0,LED_RED,1);
     if(state=='0')
         gpio_pin_set(gpio0,LED_RED,0);
    }
if((arg=='i')||(arg=='I'))  
    {if(state=='1')
       { 
         gpio_pin_set(gpio0,LED_ILLUM,1);
       }
     if(state=='0')
       {
         gpio_pin_set(gpio0,LED_ILLUM,0);
       }
    }
 bt_send_data("OK");
}




 void battery_disp()                                           // display battery history
{struct RTCDATE dt;
 int i;
  if(strlen(CMD)!=8)
    {bt_send_data("ERR 1");
     return;
    }
 uint8_t msg[40];
 for(i=0;i<6;i++)                                            // sca battery history data
    {if(PARMS.batt[i].battdt==0)                            // an emoty date
        break;                                               // means we're done
     dt=dt_to_disp(PARMS.batt[i].battdt);                   // convert the date to display values
     sprintf(msg,"%02d/%02d/%04d %02d:%02d:%02d BEF %d AFT %d",    //format the message
         dt.month, dt.day, dt.year, dt.hour, dt.minute, dt.second, 
         PARMS.batt[i].battbef, PARMS.batt[i].battaft);
     bt_send_data(msg);                                      // and send it off
     //k_sleep(K_MSEC(200));
    }
  bt_send_data("OK");
}

void volts_disp()                                             // display voltage - this is a place holder - implementation waits for hardware
{uint32_t rawvolts,volts,millivolts;
 int channel=1;
 uint8_t msg[30];
 if(strlen(CMD)!=3)
    {bt_send_data("ERR 1");
     return;
    }

 volts=rawvolts/1000;
 millivolts=rawvolts%1000;
 sprintf(msg,"IDLE VOLTS %d.%02d",volts,millivolts);
  bt_send_data(msg);
 volts=rawvolts/1000;
 millivolts=rawvolts%1000;
 sprintf(msg,"CURR VOLTS %d.%02d",volts,millivolts);
 bt_send_data(msg);
 }


void set_timezone()
{
   uint8_t msg[30],tz;
    if(strlen(CMD)!=7)                                                    // if the xommmans isn't exactly 7 chracters long
    {                                                                     // reject it with an error message
      bt_send_data("ERR 1");
      return;
    }
   tz=CMD[5];                                                             // get the time zone fron the command
   if((tz!='5')&&(tz!='6')&&(tz!='7')&&(tz!='8'))                         // check to see if it's valid
   {                                                                      // if not - reject it with an approprite error message
      bt_send_data("ERR 2");
      return;
   }                      
   PARMS.TIMEZONE=tz;                                                     // set the  time zond the parameters
   eeprom_update_parms();                                                 // go update them
   bt_send_data("OK");                                                    // and send back OK            

   
}
struct RTCDATE date_edit()
{struct RTCDATE dt;
 uint8_t work[10];
 uint32_t i;
 uint8_t monthdays[]={31,28,31,30,31,30,31,31,30,31,30,31}; 
 uint32_t year, month, day, hour,minute,second; 
 dt.year=0;
 if(CMD[21]!=RS)                                   // check fir the cirrect length
    {bt_send_data("ERR 1");
     return dt;
    }

 for(i=7;i<21;i++)                                       // check for all numdefic digits
     {if(!(isdigit(CMD[i])))
        {bt_send_data("ERR 2");
         return dt;
        }
     }
 memset(work,0,sizeof(work));                            // extract the components of the new date
 memcpy(work,&CMD[7],4);
 year=atoi(work);
 memset(work,0,sizeof(work));
 memcpy(work,&CMD[11],2);
 month=atoi(work);
 memset(work,0,sizeof(work));
 memcpy(work,&CMD[13],2);
 day=atoi(work);
 memset(work,0,sizeof(work));
 memcpy(work,&CMD[15],2);
 hour=atoi(work);
 memset(work,0,sizeof(work));
 memcpy(work,&CMD[17],2);
 minute=atoi(work);
 memset(work,0,sizeof(work));
 memcpy(work,&CMD[19],2);
 second=atoi(work);
 if((year<2021)||(year>2099))                            // edit the year
    {bt_send_data("ERR 3");
     return dt;
    }
 if ((month<1)||(month>12))                              // edit the month
    {bt_send_data("ERR 4");
     return dt;
    }
 i=year%4;                                               // if it's a leap year
 if(i==0)
    monthdays[1]=29;                                     // February has 29 days
 else monthdays[1]=28;
 if((day<1)||(day>monthdays[month-1]))                   // edut the day
    {bt_send_data("ERR 5");
     return dt;
    }
 if(hour>23)                                             // edit the hour
    {bt_send_data("ERR 6");
     return dt;
    }
 if(minute>59)                                            // edit the minute
    {bt_send_data("ERR 7");
     return dt;
    }
 if(second>59)                                            // edit the second
    {bt_send_data("ERR 8");
     return dt;
    }
 dt.year=year;                                            // builf the hsTine structure
 dt.month=month;
 dt.day=day;
 dt.hour=hour;
 dt.minute=minute;
 dt.second=second;
 return dt;
 }

 void create_batt_hist()
 {uint32_t i;
  if(strlen(CMD)!=4)
     {bt_send_data("ERR 1");
      return;
     }
  if(PARMS.batt[5].battdt!=0)                            // if the table is full
    {for(i=1;i<6;i++)                                     // shuffle off the earliest entry
        PARMS.batt[i-1]=PARMS.batt[i];
     PARMS.batt[5].battdt=0;                             // and set the latest entry to 0
     PARMS.batt[5].battbef=0;
     PARMS.batt[5].battaft=0;
    }
 for(i=0;i<6;i++)                                         // now find the first emoty slot
    if(PARMS.batt[i].battdt==0)
      break;
 PARMS.batt[i].battdt=dt_to_posix(get_rtc());
 PARMS.batt[i].battbef=i;
 PARMS.batt[i].battaft=i;
 eeprom_update_parms();                                    // go update the EEPROM
 bt_send_data("OK");
}
uint32_t calc_rtc_drift(uint32_t date1, uint32_t date2)
{uint32_t posix1,posix2,posix3;
 int32_t diff,diff2,ppm;
 int32_t diffs, diffm, diffh,i;
 uint8_t msg[30], dsign;
 posix1=date1;                                                 // get the arguments
 posix2=date2;                                 
 diff=posix1-posix2;                                         // calculate the differnece in seconds
 for(i=0;i<21;i++)                                           // now find the latest RTC set dqate and time in PARMS.
    {if(PARMS.rtc[i].timset==0)                              // it's the last non-zerro entry
         break;
    }
 if(i==0)                                                    // if there's no entry
    return 0;                                                //     we're done
 i--;                                                        //  we go to the previous entry
 posix3=PARMS.rtc[i].timset;                                 // retrieve the date and time the RTC was set
 diff2=posix2-posix3;                                        // seconds elapsed since the RTC was set
 diff=posix1-posix2;                                         // observed drift
 ppm=1000000*diff;                                           // calculatdde the drift in parts per million
 ppm=ppm/diff2;
 return ppm;                                                 //  and send it down the line
                               

}

void date_adj()                                              // apply an offset to tune the RTC
{uint8_t buffer[100];
 int16_t offset;
 int32_t i,ret;
 i=atoi(&CMD[7]);
 offset=i;
 if(((i>256)||(i<-260))&&(i!=999))                            // edit the adjustment factor
    {                                                        // adustment may be between -255 and 255 - which are net atjustments to the current value
      bt_send_data("ERR1");                                  //         or 999 - which will reset the RTC register to 0
      return;
    }
 ret=set_rtc_offset(offset);
 if(offset==0)                                              // if the request was a 0 offfset (display the current offset)
 {
   sprintf(buffer,"CURRENT OFFSET IS %d PPM",ret);          // format and 
   bt_send_data(buffer);                                    //      display the offset
 }

}

void date_set()
{struct RTCDATE dt;
 uint32_t posix1,posix2,i;
 uint8_t buff[50];
 dt=date_edit();                                           // go edit the command string
 if(dt.year==0)                                            // if the edit faied
     return;                                               // get out
 posix1=dt_to_posix(dt);                                   // go convert it to a posix date
 if(PARMS.rtc[20].timset!=0)                               // find a slot in the params hstory for the new RTC
    {for(i=1;i<21;i++)                                     // if the table is full
        PARMS.rtc[i-1]=PARMS.rtc[i];                       //   eiminate the oldest entry
     PARMS.rtc[20].timset=0;
     PARMS.rtc[20].drift=0;
    }
 i=0;                                                      // find the first empty sloit
 while(PARMS.rtc[i].timset!=0)
    i++;
/*
 if(i!=0)                                                   // if this isn't the first time the rtc was set
 {
  posix2=dt_to_posix(get_rtc());                            // get the current RTC value  
  PARMS.rtc[i].drift=calc_rtc_drift(posix1,posix2);         // and calcukate the drift
 }
 else */
 PARMS.rtc[i].drift=0;
 PARMS.rtc[i].timset=posix1;
 set_rtc(dt);
 bt_send_data("OK");
 eeprom_update_parms();     

}
void date_check()
{uint32_t posix1,posix2,posix3;
 int32_t diff,diff2,ppm;
 int32_t diffs, diffm, diffh,i;
 struct RTCDATE dt, dt2;
 uint8_t msg[50], dsign;
 dt=date_edit();                                              // go edit the date
 if(dt.year==0)                                              // if the edit failed
     return;
 posix1=dt_to_posix(dt);                                     // convert the date argument to a posix date
 posix2=dt_to_posix(get_rtc());                              // retrieve the RTC
 diff=posix1-posix2;                                         // calculate the differnece in seconds
 for(i=0;i<21;i++)                                           // now find the latest RTC set dqate and time in PARMS.
    {if(PARMS.rtc[i].timset==0)                              // it's the last non-zerro entry
         break;
    }
 if(i==0)                                                    // if there's no entry
 {
    bt_send_data("RTC NEVER SET");
    bt_send_data("NO CHECK POSSIBLE");
    return;   
 }                                                            //     we're done

 i--;                                                        //  we go to the previous entry
 posix3=PARMS.rtc[i].timset;                                 // retrieve the date and time the RTC was set
 dt=dt_to_disp(posix3);                                      // convert it to display mode
 sprintf(msg,"DATE SET %02d/%02d/%04d %02d:%02d:%02d",       //       and display it
                 dt.month,dt.day,dt.year,dt.hour,dt.minute,dt.second);
 bt_send_data(msg);
 dt=dt_to_disp(posix2);                                      // convert the RTC to display mode
 sprintf(msg,"           RTC  %02d/%02d/%04d %02d:%02d:%02d",     //      and display it
                 dt.month,dt.day,dt.year,dt.hour,dt.minute,dt.second);
 bt_send_data(msg);
 dt=dt_to_disp(posix1);                                      // convert the argument to display mode
 sprintf(msg,"SHOULD BE %02d/%02d/%04d %02d:%02d:%02d",     //      and display it
                 dt.month,dt.day,dt.year,dt.hour,dt.minute,dt.second);
 bt_send_data(msg);
 ppm=calc_rtc_drift(posix1,posix2);                          // go calcukate the drift

 sprintf(msg,"DRIFT %d SECONDS (%d PPM OVER %d DAYS)",posix1-posix2,ppm,(posix1-posix3)/86400);
 bt_send_data(msg);                                          //  and send it down the line

}

void date_hist()
{
 struct RTCDATE dt;
 int32_t i, diff,diffs, diffm, diffh;
 uint8_t msg[50],dsign;
 i=strlen(CMD);                                          // check ghe command length
 if(i!=8)
    {bt_send_data("ERR 1");
     return;
    }
 i=0;
 while(true)
    {if(PARMS.rtc[i].timset==0)                                 // if we've reached then end of the table
       break;                                                   //     we're done
     dt=dt_to_disp(PARMS.rtc[i].timset);                        // convert the time set to display format
     sprintf(msg,"%02d/%02d/%04d %02d:%02d:%02d (%d PPM)",
             dt.month,dt.day,dt.year,dt.hour,dt.minute,dt.second,PARMS.rtc[i].drift);
     bt_send_data(msg);                                        // and display it
    //k_sleep(K_MSEC(200));                                       // brief sleep
    i++;                                                       // add 1 to i
                                      
    if(i==21)                                                  // if we're at the end of the table
        break;
   }
 bt_send_data("OK");
 //k_sleep(K_MSEC(200));
}   

void params_set_sound()
{
 uint32_t i;
 uint8_t ch;
 i=strlen(CMD);                                               // get the command length
 if(i!=8)                                                     // command nust be 8 characters long
 {
   bt_send_data("ERR 1");  
   return;
 }
 ch=CMD[6];                                                   // get the argument
 if((ch!='Y')&&(ch!='N'))                                     // it must be either 'Y' or 'N'
 {
   bt_send_data("ERR 2");
   return;
 }
 PARMS.USESOUND=ch;                                           //  if the eduts passsed, update PARMS
 eeprom_update_parms();                                                    
 bt_send_data("OK");


}

void params_set_aws()
{
 uint32_t i;
 uint8_t ch;
 i=strlen(CMD);                                               // get the command length
 if(i!=8)                                                     // command nust be 8 characters long
 {
   bt_send_data("ERR 1");  
   return;
 }
 ch=CMD[6];                                                   // get the argument
 if((ch!='Y')&&(ch!='N'))                                     // it must be either 'Y' or 'N'
 {
   bt_send_data("ERR 2");
   return;
 }
 PARMS.USEAWS=ch;                                             //  if the eduts passsed, update
 if(ch=='N')
 {
	 memset(PARMS.IMEI,0,sizeof(PARMS.IMEI));
	 strcpy(PARMS.IMEI,"NONE");
 }
 eeprom_update_parms();                                                    
 bt_send_data("OK");


}
void params_set_rfid()
{
 uint32_t i,start,now;
 uint8_t ch,msg[30];
 i=strlen(CMD);                                               // get the command length
 if(i!=7)                                                     // command nust be 8 characters long
 {
   bt_send_data("ERR 1");  
   return;
 }
 ch=CMD[5];                                                   // get the argument
 if((ch!='Y')&&(ch!='N'))                                     // it must be either 'Y' or 'N'
 {
   bt_send_data("ERR 2");
   return;
 }
 if(ch=='N')                                                  // if we set it tp ]N' (NO RFID)
 {
   PARMS.USERFID=ch;                                          //  update PARMS
   memset(PARMS.RFTAG,0,sizeof(PARMS.RFTAG));                // clear the stored tag id to NULLS
   bt_send_data("OK");                                        // tell the user things are ok
   eeprom_update_parms();                                     // update the EEPROM
   return;                                                    // and get out
 }
 TIMER_RUNNING=true;
 MILLITIME=0;                                                 // reset the millisecond timer
 k_timer_start(&msclock, K_MSEC(1), K_MSEC(1));               // and start it up
 start=MILLITIME;                                             // get the start time
 motor_ccw();                                                // open the door
 
 while(true)
 {
        now=MILLITIME-start;                                  // check the timer
        if(now>60000)                                         // if more than 60 seconds have passed
        {
            bt_send_data("ERR 9");                            // send a message
            motor_cw();                                       // close the mechanism
            PARMS.LOCKSTATE='C';                              // correct the lockstate (motor_cw sets it to 'H')
            eeprom_update_parms();                            // update the EEPROM
            k_timer_stop(&msclock);                           // stop the timer
            TIMER_RUNNING=false;                              // and get out
        }
        i=gpio_pin_get(gpio0,DOORSW);                         // get the state of the door switch
        if(i==0)
            break;                                            // if it's open get out of this while loop
 }
 bt_send_data("LOAD THE NEW TAG");                            // promt the user
 while(true)                                                  // now - we wait for the door to close
 {
        now=MILLITIME-start;                                  // check the timer
        if(now>60000)                                         // if more than 60 seconds have passed
        {
            bt_send_data("ERR 10");                           // send a message
            motor_cw();                                       // close the mechanism
            PARMS.LOCKSTATE='C';                             // correct the lockstate (motor_cw sets it to 'H')
            eeprom_update_parms();                            // update the EEPROM
            k_timer_stop(&msclock);                           // stop the timer
            TIMER_RUNNING=false;
            return;                                           // and get out
        }
        i=gpio_pin_get(gpio0,DOORSW);                         // get the state of the dor switch
        if(i!=0)
            break;                                            // if it's closed get out of this while loop
 }
 motor_cw();                                                  // the door has been opened and closed
 PARMS.LOCKSTATE='C';                                         // correct the lockstate (motor_cw sets it to 'H')
 eeprom_update_parms();                                       // update the EEPROM
 k_timer_stop(&msclock);                                      // since we're done with it, stop the timer
 TIMER_RUNNING=false;

 if(i!=0)                                                     // if we didn't see a tag
 {
       bt_send_data("NO TAG");                                // tell the user
       return;                                                // and get out               
 }
 sprintf(msg,"TAG %s",RFIDTAGID);                             // the the user the tag id
 strcpy(PARMS.RFTAG,RFIDTAGID);                               // copy the tag id into the parms record
 PARMS.USERFID=ch;                                            //  if the eduts passsed, update PARMS
 eeprom_update_parms();                                                    
 bt_send_data("OK");

}
void params_set_ai()                                           // set advertising limit
{uint8_t buff[50];
 uint32_t i;
 i=strlen(CMD);                                                // see how long the command is
 if((i>11) ||(i<8))                                                          // max adversing interval allowed is 9.999 secoinds (9999 mS)
   {bt_send_data("ERR 1");
    return;
   }
 strcpy(buff,&CMD[6]);                                          // get the argument
 for(i=0;i<(strlen(buff)-1);i++)
   {if(!(isdigit(buff[i])))
      {bt_send_data("ERR 2");
       return;
      }
   }
 i=atoi(buff);                                                     // convert to an integer
 if((i<100)||(i>6000))                                                         // AI must be at east 100 mS
    {bt_send_data("ERR 3");
     return;
    }
 PARMS.ADVINT=i;
 //advertising_stop();                                               // stop advertising
 //BT_ADVERTISMENT_MIN=PARMS.ADVINT*1000/625;                       // compute the advertising intervals
 //BT_ADVERTISMENT_MAX=PARMS.ADVINT*1100/625;
 //advertising_start();
 
 sprintf(buff,"SET ADV INT  TO %d",PARMS.ADVINT);                   // log the change
  if(!LOGGING)
    logmsg_add(2,buff);
 eeprom_update_parms();                                             // update the eeprom             
 bt_send_data("OK");
}
void params_set_klim()                                               // set the keypad limit
{uint8_t buff[50];
 uint32_t i;
 i=strlen(CMD);                                                // see how long the command is
 if(i>10)                                                           // max limit is 99
   {bt_send_data("ERR 1");
    return;
   }
 strcpy(buff,&CMD[8]);                                          // get the argument
 for(i=0;i<(strlen(buff)-1);i++)
   {if(!(isdigit(buff[i])))
      {bt_send_data("ERR 2");
       return;
      }
   }
 i=atoi(buff);                                                     // convert to an integer
 if(i<1)                                                           // minimum is 1
    {bt_send_data("ERR 3");
     return;
    }
 PARMS.ERRLMT=i;
 sprintf(buff,"SET KEYPAD ERR LIMIT TO %d",PARMS.ERRLMT);
 if(!LOGGING)
    logmsg_add(2,buff);
 eeprom_update_parms();                                             // update the eeprom   
 bt_send_data("OK");
}
void params_set_kto() 
{                                                                  // set the keypad timeout
 uint8_t buff[50];
 uint32_t i;
 i=strlen(CMD);                                                    // see how long the command is
 if(i!=9)                                                           // max timeout is 9
   {bt_send_data("ERR 1");
    return;
   }
 strcpy(buff,&CMD[7]);                                             // get the argument
 for(i=0;i<(strlen(buff)-1);i++)
   {if(!(isdigit(buff[i])))
      {bt_send_data("ERR 2");
       return;
      }
   }
 i=atoi(buff);                                                     // convert to an integer
 if(i<1)                                                           // minimum is 1
    {bt_send_data("ERR 3");
     return;
    }
 PARMS.ERRTMO=i;
 sprintf(buff,"SET KEYPAD TMOUT TO %d",PARMS.ERRTMO);
  if(!LOGGING)
    logmsg_add(2,buff);
  eeprom_update_parms();                                             // update the eeprom   
 bt_send_data("OK");
}

void params_set_lowvoltage()
{
   uint8_t buff[50];
   uint16_t voltage;
   uint32_t i;
   i=strlen(CMD);                                                  // get the length od the command
   if(i!=11)                                                       // this command must be exactly 10 chracters long "SETLVL9999,"
   {
      bt_send_data("ERR 1");                                       // if it isn't - send an error message
      return;                                                      // abd returb                                       
   }
 voltage=atoi(&CMD[6]);                                            // convert to a 16 bit integer
 if((voltage<4000)||(voltage>5500))                                // it must be between 4000 and 5500 (these are millivolts)
 {
   bt_send_data("ERR 2");                                          // if not  - send an error message
   return;                                                         // and get out
 }
 PARMS.LOWVOLTAGE=voltage;                                         // otherwise - set the voltage
 eeprom_update_parms();                                            // update the EEPROM
 sprintf(buff,"SET LOW VOLTS to %d",voltage);                      // build a message
  if(!LOGGING)
    logmsg_add(2,buff);                                               // store it in the messages file
 bt_send_data("OK");                                               // and send a message 
}
void params_set_ito() 
{                                                                  // set the ide timeout
 uint8_t buff[50];
 uint32_t i;
 i=strlen(CMD);                                                    // see how long the command is
 if(i!=10)                                                          // must be two digits
   {bt_send_data("ERR 1");
    return;
   }
 strcpy(buff,&CMD[7]);                                          // get the argument
 for(i=0;i<(strlen(buff)-1);i++)
   {if(!(isdigit(buff[i])))
      {bt_send_data("ERR 2");
       return;
      }
   }
 i=atoi(buff);                                                     // convert to an integer
 if((i<10)||(i>60))                                                           // minimum is 10
    {bt_send_data("ERR 3");
     return;
    }
 PARMS.INATMO=i;
 sprintf(buff,"SET KPAD IDLE TMOUT TO %d",PARMS.INATMO);
  if(!LOGGING)
    logmsg_add(2,buff);
  eeprom_update_parms();                                             // update the eeprom   
 bt_send_data("OK");
}

void params_disp()
{
 uint8_t msg[30],work[40];
struct RTCDATE date;
 if(strlen(CMD)!=7)
      {bt_send_data("ERR 1");
       return;
      }
 date=dt_to_disp(PARMS.commdt);
 sprintf(work,"COMMISSIONED %02d/%02d/%04d %02d:%02d:%02d", 
               date.month,date.day,date.year,date.hour,date.minute,date.second);
 bt_send_data(work);
 memset(work,0,sizeof(work));
 memmove(work,PARMS.lockid,sizeof(PARMS.lockid));
 sprintf(msg,"ID %s",work);
 bt_send_data(msg);
 memset(work,0,sizeof(work));
 memmove(work,PARMS.crkey,sizeof(PARMS.crkey));
 sprintf(msg,"KEY %s",work);
 bt_send_data(msg);
 sprintf(msg,"FW VERSION %s",PARMS.FWVERSION);
 bt_send_data(msg);
 sprintf(msg,"TIMEZONE %c",PARMS.TIMEZONE);
 bt_send_data(msg);
 sprintf(msg,"ADVINT %d",PARMS.ADVINT);
 bt_send_data(msg);;
 sprintf(msg,"LOW VOLTAGE LIMIT %d",PARMS.LOWVOLTAGE);
 bt_send_data(msg);
 sprintf(msg,"PAD ERR LIMIT %d",PARMS.ERRLMT);
 bt_send_data(msg);
 sprintf(msg,"PAD ERR TIMEOUT %d",PARMS.ERRTMO);
 bt_send_data(msg);
 sprintf(msg,"PAD IDLE TIMEOUT %d",PARMS.INATMO);
 bt_send_data(msg);
 sprintf(msg,"RATIO %d", PARMS.RATIO);
 bt_send_data(msg);
  sprintf(msg,"LASTBATT %d",PARMS.LASTBATT);
 bt_send_data(msg);
 sprintf(msg,"USE SOUND %c",PARMS.USESOUND);
 bt_send_data(msg);
  sprintf(msg,"USE RFID %c",PARMS.USERFID);
 bt_send_data(msg);
 if(PARMS.USERFID=='Y')
 {
   sprintf(msg,"RFTAG %s",PARMS.RFTAG);
   bt_send_data(msg);
 }
 sprintf(msg,"USE AWS %c",PARMS.USEAWS);
 bt_send_data(msg);
 if(PARMS.USEAWS=='Y')
 {
   sprintf(msg,"IMEI %s",PARMS.IMEI);
   bt_send_data(msg);
 }
 if(PARMS.MOTORMODE=='1')
      bt_send_data("MOTOR SINGLE PHASE");
 else bt_send_data("MOTOR DUAL PHASE");
  
sprintf(msg,"ALERT TIMEOUT %d SECONDS",PARMS.TIMEOUTDELAY);
bt_send_data(msg);
 sprintf(msg,"LOCK STATE %c",PARMS.LOCKSTATE);
 bt_send_data(msg);
 date=dt_to_disp(PARMS.LASTBOOT);
 sprintf(work,"LASTBOOT %02d/%02d/%04d %02d:%02d:%02d", 
               date.month,date.day,date.year,date.hour,date.minute,date.second);
 bt_send_data(work);


}    
void display_firmware()
{
 uint8_t msg[20];
 if(strlen(CMD)!=8)
    {bt_send_data("ERR 1");
     return;
    }
 #ifdef NRF53
    bt_send_data("NRF53");

 #endif
 #ifdef NRF52
    bt_send_data("NRF52");
 #endif
 sprintf(msg,"REV %s",FWVERSION);
 bt_send_data(msg); 
}
void get_batt()
{uint32_t millivolts;
 uint8_t buffer[50];

 if(millivolts<1000)
    {bt_send_data("NO VOLTAGE");
     return;
    }
 sprintf(buffer,"CURRENT %d MILLIVOLTS",millivolts);
 bt_send_data(buffer);
 sprintf(buffer,"IDLE   %d MILLIVOLTS",IDLEVOLTAGE);
 bt_send_data(buffer);
}

void get_date()
{struct RTCDATE date;
 uint8_t buffer[50];
 date=get_rtc();
 memset(buffer,0,sizeof(buffer));
 sprintf(buffer,"%02d:%02d:%02d %02d/%02d/%04d(%d)",date.hour,date.minute,date.second,date.month,date.day,date.year,date.weekday);
 bt_send_data(buffer);
}

             
void sound_set_vol()
{ 
   bt_send_data("DEPRECATED");
}
void sound_beep()
{

 bt_send_data("OK");
}

void set_ratio()
{uint8_t buff[50];
 int i,j;
 i=strlen(CMD);
 if((i>9)||(i<7))                                                               // edit ratio
 {
   bt_send_data("ERR 1");                                                       // must be between 7 and 9 characters long
   return;
 }
 for(j=5;j<(i-1);j++)
 {
   if(isdigit(CMD[j]))                                                         // arguments must be numeric
       continue;
   bt_send_data("ERR 2");
   return;
   
 }
 i=PARMS.RATIO;
PARMS.RATIO=atoi(&CMD[5]);                                                       // set the gearr ratio - note that this the total gear ratio -
                                                                                // the motor gerr ratio times the gear train ratio
 sprintf(buff,"RATIO %d",PARMS.RATIO);
 bt_send_data(buff);

 sprintf(buff,"SET RATIO TO %d",PARMS.RATIO);
  if(!LOGGING)
    logmsg_add(2,buff);
 
 eeprom_update_parms();
 }

void test_sws()
{
   uint32_t ret;
   //bt_send_data("SWITCH TEST");
 
      ret=gpio_pin_get(gpio0,HASPSW);
      if(ret>0)
         bt_send_data("HASP=1");
      else bt_send_data("HASP=0");
      ret=gpio_pin_get(gpio0,DOORSW);
      if(ret>0)
         bt_send_data("DOOR=1");
      else bt_send_data("DOOR=0");
      ret=gpio_pin_get(gpio0,CNTRSW);
      if(ret>0)
         bt_send_data("CNTR=1");
       else bt_send_data("CNTR=0");

   return;
  
}
void motor_nudge()
{
uint32_t maxsteps,i,j,steps;
 uint8_t buff[50], dir;
 if(PARMS.RATIO==0)                                                               // if the gear ratio isn't set
    {bt_send_data("GEAR RATIO MUST BE SET");                                    // send a message
     return;                                                                    // and get out
    }
 dir=CMD[4];                                                                    // get the direction of the nudge
 if(dir=='r')                                                                   // convrt to iupper case
     dir='R';
 if(dir=='l')
     dir='L';
 if((dir!='R')&&(dir!='L'))                                                     // direction must be either 'R' or 'L'
 {
   bt_send_data("INVALID DORECTION");
   return;

 }
 steps=atoi(&CMD[5]);     
 if(steps==0)
    {bt_send_data("STEPS CANNOT BE 0");
     return;
    }
                                                                      // max steps for 90 degrees
                                            
 for(i=0;i<steps;i++)  
    {   
      if(dir=='L')                                                                        // so - we rotate the mechanism
        motor_spin(1,1);                                                                  // step the motor once (18 degrees)
      else motor_spin(0,1);
    }



}
void motor_cw()                                                                 // spin the motor 90 degrees clockwise
{uint32_t maxsteps,i;
 uint8_t buff[50];
 if(PARMS.RATIO==0)                                                             // if the gear ratio isn't set
    {bt_send_data("GEAR RATIO MUST BE SET");                                    // send a message
     return;                                                                    // and get out
    } 
 gpio_pin_set(gpio0,LED_ILLUM,0);                                               // turn off the ILLUMINAATION LEDs
 maxsteps=5*PARMS.RATIO/4;                                                      // each step moves the otor 72 degrees - five steps is one rotation of the motor
                                                                                // RATIO is 360 degrees of the mechanism - hence the calculation
 sprintf(buff,"%d STEPS", maxsteps);
 bt_send_data(buff);
 k_sem_give(&voltage_mon_on);                                                    // start motor monitoring                                              
 for(i=0;i<maxsteps;i++)                                                         // so - we rotate the mechanism
     motor_spin(0,1);                                                            // step the motor once 72 degrees
 k_sem_give(&voltage_mon_off);                                                   // stop monitoring the voltage
 if(TESTING)                                                                     // if we're testing the finall assembly
      bt_send_data("OK");                                                        //       we need to tell the test program                                    
 sprintf(buff,"LOW VOLTAGE %d CNT %d",LOW_VOLTAGE, LVCNT);                       // finally,, send the voltage report         
 bt_send_data(buff);                                                                            
}
void motor_ccw()                                                                // spin the motor 90 degrees counter-clockwise
{uint32_t maxsteps,i;
 uint8_t buff[50];
 gpio_pin_set(gpio0,LED_ILLUM,0);                                               // turn off the ILLUMINAATION LEDs
 if(PARMS.RATIO==0)                                                             // if the gear ratio isn't set
    {bt_send_data("GEAR RATIO MUST BE SET");                                    // send a message
     return;                                                                    // and get out
    } 
 maxsteps=5*PARMS.RATIO/4;                                                      // each step moves the otor 72 degrees - five steps is one rotatio  of the otor
                                                                                // RATIO is 360 degrees of the mechanism - hence the calculation
 sprintf(buff,"%d STEPS", maxsteps);
 bt_send_data(buff);
 k_sem_give(&voltage_mon_on);                                                     // start monitoring motor voltage
 for(i=0;i<maxsteps;i++)                                                        // we rotate the mechanism
     motor_spin(1,1);                                                           // step the motor once  - 72 degrees
 k_sem_give(&voltage_mon_off);                                                    // stop monitoring the voltage 

    
if(TESTING)                                                                     // if we're testing the finall assembly
      bt_send_data("OK");                                                       //       we need to tell the test program                                   
 sprintf(buff,"LOW VOLTAGE %d CNT %d",LOW_VOLTAGE, LVCNT);                  
 bt_send_data(buff);                                                                                       
}
void check_center()                                                             // check that the motor is perfectly centered
{
   int32_t cnt1, cnt2, cnt3, ret;
   uint8_t buff[50];
   ret=gpio_pin_get(gpio0,CNTRSW);                                              // go look at the CENTER swutch
   sprintf(buff,"CK CENTER ");
   if(VDD2_UP)
         strcat(buff,"VDD2 UP");
   else strcat(buff," VDD2 DN");
   if(ret==0)
        strcat(buff," RET 0");
   else strcat (buff,"RET 1");
   bt_send_data(buff);
   k_sleep(K_MSEC(1000));
   if(ret==0)                                                                   // if we're not over the hall effect sensor
   {
      bt_send_data("ERR1");                                                     // inform the user
      PARMS.LOCKSTATE='U';                                                      // we're lost - set the lock state to unknown
      eeprom_update_parms();                                                    // and go update the eeprom copy of params
      return;                                                                   // and get out - tthe calling routine wil handle the error
      
   }
   cnt1=0;                                                                      // reset the counters
   cnt2=0;
   cnt3=0;
   k_sem_give(&voltage_mon_on);                                                 // start motor monitoring  
   while(true)                                                                  // and loop
   {
      ret=gpio_pin_get(gpio0,CNTRSW);                                           // readig the hall effect sensor
      if(ret==0)                                                                // if it went open
           break;                                                               //     get out of the loop
      cnt1++;                                                                   // otherwise add 1 to this loop counter
      motor_spin(1,1);                                                          // step the motor once  - 72 degrees
   }
   motor_spin(0,cnt1);                                                          // return the motor to where it was wwhen we came into this routine 
   while(true)                                                                  // and loop - spinning the other way
   {
      ret=gpio_pin_get(gpio0,CNTRSW);                                           // readig the hall effect sensor
      if(ret==0)                                                                // if it went open
           break;                                                               //     get out of the loop
      cnt2++;                                                                   // otherwise add 1 to this loop counter
      motor_spin(0,1);                                                          // step the motor once  - 72 degrees
   }    
   cnt3=(cnt2+cnt1)/2;                                                          // calculate the steps bacck to true center
   motor_spin(1,cnt3);                                                          // and move the motor back to true center
   k_sem_give(&voltage_mon_off);                                                // stop monitoring the voltage 
   sprintf(buff,"LOW VOLTAGE %d CNT %d",LOW_VOLTAGE, LVCNT);                    // and build and send the voltage report       
   bt_send_data(buff);   
   sprintf(buff,"CNTRCHK %d %d %d",cnt1, cnt2, cnt3);                            /// build the summary line
   bt_send_data(buff);                                                          //  and send it back to the user
   PARMS.LOCKSTATE='C';                                                         // set the lock state to centered
   eeprom_update_parms();                                                       // and go update the eeprom copy of params

}
/*
void centerx()
{
   uint32_t ret,cnt1, cnt2, cnt3,cnt4,i;
   uint8_t buff[50],doorpos,cmd1[10],cmd2[10],cmd3[10],cmd4[10];
   doorpos=PARMS.LOCKSTATE;                                                      // get the lockstate
   strcpy(cmd1,"NUDGL1");                                                        // set the defaualt command sequence
   strcpy(cmd2,"NUDGR20"); 
   strcpy(cmd3,"NUDGR1");
   strcpy(cmd4,"NUDGL1");
   if(doorpos!='D')                                                              // if it was the HASP that just closed
   {
         strcpy(cmd1,"NUDGR1");                                                  // flip the command sequence
         strcpy(cmd2,"NUDGL20"); 
         strcpy(cmd3,"NUDGL1");
         strcpy(cmd4,"NUDGR1");
   }

   ret=gpio_pin_get(gpio0,CNTRSW);                                               // go look at the CENTER swutch
   if(ret==0)                                                                    // if it's open
   {
      bt_send_data("CENTEER SW IS OPEN");
      return;
   }
   cnt1=0;   ;
   cnt2=0;                                                                       // zero out the counts
   cnt3=0;
   cnt4=0;
   while(true)                                                                   // nudge the mechanism off the center swutch
   {
      ret=gpio_pin_get(gpio0,CNTRSW);                                            // look at the switch
      if(ret==0)                                                                 // if it's open
           break;                                                                //       get out
      cnt1++;                                                                    // otherwise, increment the count
      strcpy(CMD,cmd1);                                                         // and do a nudge
      motor_nudge();                                                             // left 1 step
   }
   while(true)                                                                   // now nudge the mechanism back on center swutch
   {
      ret=gpio_pin_get(gpio0,CNTRSW);                                            // look at the switch
      if(ret==1)                                                                 // if it's closed
           break;                                                                //       get out
      cnt2=cnt2+20;                                                              // otherwise, increment the count
      strcpy(CMD,cmd2);                                                          // and do a nudge
      motor_nudge();                                                             //    20  steps
   }
   while(true)                                                                   // now nudge the mechanism back off center swutch
   {
      ret=gpio_pin_get(gpio0,CNTRSW);                                            // look at the switch
      if(ret==0)                                                                 // if it's open
           break;                                                                //       get out
      cnt3++;                                                                    // otherwise, increment the count
      strcpy(CMD,cmd3);                                                          // and do a nudge
      motor_nudge();                                                             // right 1 step
   }

   i=cnt3/2;                                                                     // calcuate the distance to nudge back
   while(i>0)                                                                    // nd nudged back to the center
   {
      strcpy(CMD,cmd4);                                                          // and do a nudge
      motor_nudge(); 
      i--;
      cnt4++;
   }
   sprintf(buff,"XCNTR SUMMARY %d %d %d %d", cnt1, cnt2,cnt3, cnt4);
   bt_send_data(buff);

}
*/


void center_motorx(int dir)                                                      // center the motor - spin the motor a maimmum of one revolution of the mechanism
                                                                                //     until the motor centered switch closes
{uint32_t maxsteps,i,cnt1,ret;
 uint8_t buff[50],nudgcd;
 if(PARMS.RATIO==0)                                                             // if the gear ratio isn't set
    {bt_send_data("GEAR RATIO MUST BE SET");                                    // send a message
     return;                                                                    // and get out
    }               
  maxsteps=5*PARMS.RATIO;                                                       // the step angle of the motor is 72 degrees per step
                                                                                // so five times RATIO is 360 degrees of rotation 
  cnt1=0;                                                                       // set the step count to 0
  k_sem_give(&voltage_mon_on);                                                  // and start the voltage monitoring task
  for(i=0;i<maxsteps;i++)                                                       // so - we rotate the mechanism
    {                                                     
      ret=gpio_pin_get(gpio0,CNTRSW);                                           //  test to see if the center test switch is closed
      if(ret>0)                                                                 //  if it is
             {
              k_sem_give(&voltage_mon_off);                                     //  stop monitoring the voltage
              sprintf(buff,"LOW VOLTAGE %d CNT %d",LOW_VOLTAGE, LVCNT);         //  report the resultd
              bt_send_data(buff); 
              sprintf(buff,"OK %d STEPS",cnt1+15);                              //  notify the caller - the nudge is included in the count
              bt_send_data(buff);   
              if(dir==1)                                                        // set a nudge direction
                  nudgcd='L';
              else nudgcd='R'; 
              sprintf(CMD,"NUDG%c15",nudgcd);                                   // build the nudge command and go 15 more steps
              bt_send_data(CMD);
              motor_nudge();    
              check_center();                                                   // now - complete centring the motor
              return;                                                           //      and get out                                                
             } 
     if(dir==1)                                                                 // if the dirction is 1
         motor_spin(1,1);                                                       // step the motor once CCW
     else motor_spin(0,1);                                                      // else step the motor CW
     cnt1++;                                                                    // increment the step count
    }
 k_sem_give(&voltage_mon_off);                                                  // if we get here - we've failed - stop monitoring the voltage
 sprintf(buff,"LOW VOLTAGE %d CNT %d",LOW_VOLTAGE, LVCNT);                      // format and send the voltage report
 bt_send_data(buff);  
                                                   // play a funky sund
 sprintf(buff,"ERR3 %d",cnt1);                                                  // format and send an error report
 bt_send_data(buff);
 PARMS.LOCKSTATE='C';                                                           // set the lock state to Unkonwn
 eeprom_update_parms();                                                         // and go update the eeprom copy of params
           
                                                                
}
void center_motor()                                                             // center the motor via the "CNTR" command
{
   uint32_t i;
   uint8_t dir=9;
   i=strlen(CMD);                                                               // get the length of the command
   if((i!=5)&&(i!=6))                                                           // the command must be either five or six  characters
   {
      bt_send_data("ERR1");
      return;
   }
   dir=CMD[4];                                                                  // get the fourth character
   if(dir==',')                                                                 // if it's a comma
       dir='0';                                                                 // assume dir 0'
   if(dir=='0')
        center_motorx(0);
   else if(dir=='1')
             center_motorx(1);
        else bt_send_data("ERR2");

}

void play_sound_samples()
{int i;
   if(PARMS.USESOUND=='N')
   {
      bt_send_data("SOUND DISABLED");
      return;
   }
   i=atoi(&CMD[5]);
   
}
void echo_keypad()
{
   uint8_t buffer[30];
   strcpy(buffer,CMD);
   buffer[strlen(buffer)-1]=0;                                                 // get rid of the trailing comma
   bt_send_data("KEYPAD INPUT");
   bt_send_data(buffer);
      
   
      
}
void force_error()                                                           // this routine shoud force an error
{
   uint8_t buff[10];
   buff[5000]='X';                                                           // by trying to put a character in a rediculous place
}

void que_comm()
{
   uint8_t buffer1[100];
   uint32_t ret, i;

   

   ret=gpio_pin_get(gpio0,Q_STATUS);                                   // read the STATUS pin   if(ret==1) 
   if(ret==1)                                                          // if status is high - remember that
   {                                                                   //     status is invrted
      bt_send_data("CHIP IS DOWN");                                    // send a message
      return;                                                          //    and get out
   }
	memset(buffer1,0,sizeof(buffer1));                       // set up and send the data
   strcpy(buffer1,&CMD[4]);
   i=strlen(buffer1);                                     // if there is a comma
   if(buffer1[i-1]==',')                                    // at the end of the quectel command string
        buffer1[i-1]=0;                                     // elimiate it
   qmsgsend(buffer1);
                                                // then leave
    
}

void que_certld()                                                      // load the quectel chip with
{                                                                      // AWS credentials
     qcertsload();  

}

void que_update()
{
   uint32_t ret;
   gpio_pin_set(gpio0,LED_GREEN,0);                                   // turn off the green LED
   gpio_pin_set(gpio0,LED_ILLUM,0);                                   //  turn off the ILLUMINATION LEDs
   FLASHER_MODE=1;                                                    // set the led RED-GREN sequence and timing
   k_timer_start(&flasher, K_MSEC(1000), K_MSEC(1000));               // and kick off the LEDs
   if(QPOWEREDUP)                                                     // if the module is powered up - something is wrong                                     
   {
        bt_send_data("MODULE IS ALREADY POWERED UP");                 // send a message
        quectel_powerdown() ;                                         // power it down
        FLASHER_MODE=0;                                               // reset the flahing LEDs
        gpio_pin_set(gpio0, LED_GREEN,0);
        gpio_pin_set(gpio0, LED_RED,0);
        k_timer_stop(&flasher);
        return;                                                       // and get out
   }

   ret= quectel_powerup();                                            // power uo the module
   if(!QPOWEREDUP)                                                    // if there was a failure
   {
      bt_send_data("POWER UP FAILURE");                               // send a message
      if(!LOGGING)
           logmsg_add(2,"QUPDATE FAILURE 3");                              // log the failure
      FLASHER_MODE=0;                                                // reset the flahing LEDs
      gpio_pin_set(gpio0, LED_GREEN,0); 
      gpio_pin_set(gpio0, LED_RED,0);
      k_timer_stop(&flasher);
      return;                                                         // and get out
   }


   qconnect();                                                        // connect to the server


   if(!QCONNECTED)                                                    // if there was a failure
   {
   
      bt_send_data("CONNECT FAILURE");                                // send a message
      if(!LOGGING)
          logmsg_add(2,"QUPDATE FAILURE 4");                              // log the failure
      quectel_powerdown();                                            // power dwn the chip
      FLASHER_MODE=0;                                                 // reset the flahing LEDs
      gpio_pin_set(gpio0, LED_GREEN,0);
      gpio_pin_set(gpio0, LED_RED,0);
      k_timer_stop(&flasher);
      return;                                                         // and get out
  
   }

   que_post();                                                        // post the updates to the server
   que_disconnect();                                                  // disconnect from the server
   quectel_powerdown();                                               // and powerdown the quectel chip
   FLASHER_MODE=0;                                                    // reset the flahing LEDs
   gpio_pin_set(gpio0, LED_GREEN,0);
   gpio_pin_set(gpio0, LED_RED,0);
   k_timer_stop(&flasher);
}
void target_cb()
{
   bt_send_data("GOT TO TARGET CALLBACK");
}

void erase_secondary_slot(void)
{
    const struct flash_area *fa;
    uint8_t buffer[100];
    int err = flash_area_open(SECONDARY_SLOT_ID, &fa);
    if (!err) {
        bt_send_data("Erasing secondary firmware slot...");
        sprintf(buffer,"OFFSET=%x SZ=%x",fa->fa_off,fa->fa_size);
        bt_send_data(buffer);
        err = flash_area_erase(fa, 0, fa->fa_size);
        if (err) {
            sprintf(buffer,"Failed to erase secondary slot (err %d)", err);
            bt_send_data(buffer);
        } else {
            bt_send_data("Secondary slot erased successfully!");
        }
        flash_area_close(fa);
    } else {
      sprintf(buffer,"Failed to open secondary slot (err %d)", err);
      bt_send_data(buffer);
    }
}
    
void que_fw_download()
{
    uint8_t buffer[1200],buffer2[1200],buffer3[100];
    uint8_t hexchars[]="0123456789ABCDEF";
    uint8_t hexchar1,hexchar2,hexchar3,hexchar4,hexchar5;
    int32_t cksumgiven, cksum, filesize, bytesleft,xblocknbr,xblocksize,xchksum,blocknbr,ychksum,i,j,k;
    uint8_t fwblock[1708]="000 512 12327\
 9 3DB8F3960000000000020000589403000000000000000000\
 0000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
 FFFFFFFFFFFFFFFFFFFFFFFFFFFFF";
    memset(buffer,0,sizeof(buffer));                                           // clear the buffers to nulls
    memset(buffer2,0,sizeof(buffer2)); 
    memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));                        // isolate lockid as a null-terminated string
    
    strcpy(buffer,"AT+QMTPUBEX=2,1,1,0,\"/");                                  // and buid the PUBEX header
    strcat(buffer,buffer2);
    strcat(buffer,"/activity\",\"");
    strcat(buffer,"FWGET 1.9.6\"");                                            // this is a Firmware Get
    memset(buffer3,0,sizeof(buffer3));                                         // clear buffer 3
    sprintf(buffer3,"BEGAN FW 1.9.6 DOWNLOAD");                                // format an event log message
    logmsg_add(2,buffer3);                                                     // and log the event
    strcpy(PATTERN,"confirm");                                                 // tell the message received thread what to look for
    PATTERNFOUND=false;                                                        //   and reset the PATTERNFOUND flag
    ALARM=false;                                                               // turn off the ALARM
    k_timer_start(&alarm,K_MSEC(8000),K_NO_WAIT);                              // set the alarm clock to 4 seconds
    qmsgsend(buffer);                                                          // and send the command to the Quectel module
	 while((!ALARM)&&(!PATTERNFOUND))                                           // now wait for either the pattern to be recevied or the alarm to go off
	   {
             k_sleep(K_MSEC(50)); 
      }
	 if(ALARM) 
	   {                                                                           // if it went off
		    bt_send_data("NO CONFIRM on FWGET!");                                           // inform the user
          k_timer_stop(&alarm);                                                  // turn off the alarm clock
          return;                                                                // and get out
	   }
   memset(buffer,0,sizeof(buffer));                                             // now - we get the filesize and checksum
   memmove(buffer,&PATTERNREC[37],30); 
   filesize=atoi(&buffer[2]); 
   cksumgiven=atoi(&buffer[11]);
   sprintf(buffer,"FILESIZE %d CKSUM %d",filesize,cksumgiven);
   bt_send_data(buffer);


   cksum=0;                                                                    // set up to read the binary image - we set the cksum to
   bytesleft=filesize;                                                         //      zero and the bytes left to download to the given filesize
   blocknbr=0;
   while(bytesleft>0)                                                          // and we go into a read loop
   {
      memset(buffer,0,sizeof(buffer));                                         // clear the buffers to nulls
      memset(buffer2,0,sizeof(buffer2)); 
            memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));                 // isolate lockid as a null-terminated string
      strcpy(buffer,"AT+QMTPUBEX=2,1,1,0,\"/");                                 // and build the PUBEX header
      strcat(buffer,buffer2);
      strcat(buffer,"/activity\",\"");
      sprintf(buffer2,"FWBLK %d\"",blocknbr);
      strcat(buffer,buffer2);                                                    // the publish header is built

      strcpy(PATTERN,"confirm");                                                 // tell the message received thread what to look for
      PATTERNFOUND=false;                                                        //   and reset the PATTERNFOUND flag
      ALARM=false;                                                               // turn off the ALARM
      k_timer_start(&alarm,K_MSEC(40000),K_NO_WAIT);                              // set the alarm clock to 4 seconds
      qmsgsend(buffer);                                                          // and send the command to the Quectel module
      while((!ALARM)&&(!PATTERNFOUND))                                           // now wait for either the pattern to be recevied or the alarm to go off
        {
               k_sleep(K_MSEC(50)); 
        }
      if(ALARM) 
        {                                                                           // if it went off
            bt_send_data("NO CONFIRM on FWGET!");                                           // inform the user
            k_timer_stop(&alarm);                                                  // turn off the alarm clock
            return;                                                                // and get out
        }
        xblocknbr=atoi(&PATTERNREC[37]);                                           // get the block params
        xblocksize=atoi(&PATTERNREC[41]);
        xchksum=atoi(&PATTERNREC[45]);
        ychksum=0;                                                                  // set the calculated block checksum to 0
        memset(buffer,0,sizeof(buffer));                                           // clear the buffer to NULLs
        memmove(buffer,&PATTERNREC[52],1024);                                        // get the encoded HEX data
        memset(buffer3,0,sizeof(buffer3));
        memmove(buffer3,PATTERNREC,40);
        //bt_send_data(buffer3);
        memset(buffer2,0,sizeof(buffer2));                                         // clear the target to NULLS
        //bt_send_data(buffer);                                                      // display the encoded hex data
        if(bytesleft>512)                                                           // calculate the umber of bytes to be decoded
             k=512;
        else k=bytesleft;
        hexchar3='0';
        hexchar4='0';
        for(i=0;i<k;i++)                                                          // now - scan the encoded hex data
        {
         hexchar1=buffer[i*2];                                                     // get a pair of hex characters
         hexchar2=buffer[i*2+1];
         for(j=0;j<16;j++)                                                         // translate each character to it's hex equivalent
             {
               if(hexchars[j]==hexchar1)
               {
                  hexchar3=j;
                  break;
               }
             } 
             for(j=0;j<16;j++)                                                         // translate each character to it's hex equivalent
             {
               if(hexchars[j]==hexchar2)
               {
                  hexchar4=j;
                  break;
               }
             }

         hexchar5=hexchar3<<4;
         hexchar5+=hexchar4;                                                            // assemble the target hes character
         buffer2[i]=hexchar5;                                                           // put it in the buffer
         //sprintf(buffer3,"%c %c %02x %02x %02x ",hexchar1,hexchar2,hexchar3,hexchar4,hexchar5);
         //bt_send_data(buffer3);
        cksum+=hexchar5;                                                                // and add it to the cksum
        ychksum+=hexchar5;
        }   
       
        sprintf(buffer,"%02X%02X%02X%02X%02x%02X cksum %d left %d block=%d size=%d sum=%d xsum=%d",buffer2[0],buffer2[1],buffer2[2],buffer2[3],buffer2[4],buffer2[5],cksum,bytesleft,
                          xblocknbr,xblocksize,xchksum,ychksum);
        bt_send_data(buffer);
        if((xchksum!=ychksum)||(xblocknbr!=blocknbr))                                   // if this block is in error
        {

               cksum-=ychksum;                                                         // take away the checksum that is in error
               bt_send_data("BAD BLOCK BAD BLOCK BAD BLOCK BAD BLOCK");                // put a message in the output data stream (so I can find it in the data dump)
               continue;                                                               // and go retry
        }
        bytesleft=bytesleft-k;  
        if(xblocknbr==0)                                                                 // if this is block 0
        {
         i=dfu_target_img_type	(	buffer2,xblocksize);                              // go figure outimage type
         sprintf(buffer,"DFU TYPE IS %d",i);
         bt_send_data(buffer);
         erase_secondary_slot();
         i=dfu_target_reset();
         sprintf(buffer,"TARGET RESET RETURNED %d",i);
         bt_send_data(buffer);
         i=dfu_target_init(DFU_TARGET_IMAGE_TYPE_MCUBOOT,2,filesize,NULL);
         
         sprintf(buffer,"TARGET INIT RETURNED %d",i);
         bt_send_data(buffer);
        }
        blocknbr++;                                                                // increment the block numbe                                               
   }
   memset(buffer3,0,sizeof(buffer3));                                              // set up to record the end of the download
   sprintf(buffer3,"GOT %d BYTES",filesize);
   logmsg_add(2, buffer3);
   sprintf(buffer3,"CKSUM %d",cksum);
   if(cksum==cksumgiven)
       strcat(buffer3," OK");
   else strcat(buffer3," BAD CKSUM");
   logmsg_add(2, buffer3);
}
void qget_firmware()
{
   uint32_t ret;
   gpio_pin_set(gpio0,LED_GREEN,0);                                   // turn off the green LED
   gpio_pin_set(gpio0,LED_ILLUM,0);                                   //  turn off the ILLUMINATION LEDs
   FLASHER_MODE=1;                                                    // set the led RED-GREN sequence and timing
   k_timer_start(&flasher, K_MSEC(1000), K_MSEC(1000));               // and kick off the LEDs
   if(QPOWEREDUP)                                                     // if the module is powered up - something is wrong                                     
   {
        bt_send_data("MODULE IS ALREADY POWERED UP");                 // send a message
        quectel_powerdown() ;                                         // power it down
        FLASHER_MODE=0;                                               // reset the flahing LEDs
        gpio_pin_set(gpio0, LED_GREEN,0);
        gpio_pin_set(gpio0, LED_RED,0);
        k_timer_stop(&flasher);
        return;                                                       // and get out
   }
  
   bt_send_data("BEFORE POWERUP");
   ret= quectel_powerup();                                            // power uo the module
   if(!QPOWEREDUP)                                                    // if there was a failure
   {
      bt_send_data("POWER UP FAILURE");                               // send a message
      if(!LOGGING)
           logmsg_add(2,"QUPDATE FAILURE 3");                              // log the failure
      FLASHER_MODE=0;                                                // reset the flahing LEDs
      gpio_pin_set(gpio0, LED_GREEN,0); 
      gpio_pin_set(gpio0, LED_RED,0);
      k_timer_stop(&flasher);
      return;                                                         // and get out
   }
   bt_send_data("GOT PAST POWER UP");

   qconnect();                                                        // connect to the server


   if(!QCONNECTED)                                                    // if there was a failure
   {
   
      bt_send_data("CONNECT FAILURE");                                // send a message
      if(!LOGGING)
          logmsg_add(2,"QUPDATE FAILURE 4");                              // log the failure
      quectel_powerdown();                                            // power dwn the chip
      FLASHER_MODE=0;                                                 // reset the flahing LEDs
      gpio_pin_set(gpio0, LED_GREEN,0);
      gpio_pin_set(gpio0, LED_RED,0);
      k_timer_stop(&flasher);
      return;                                                         // and get out
  
   }
   bt_send_data("GOT TO FW DOWNLOAD");
   que_fw_download();                                                        // post the updates to the server
   que_disconnect();                                                  // disconnect from the server
   quectel_powerdown();                                               // and powerdown the quectel chip
   FLASHER_MODE=0;                                                    // reset the flahing LEDs
   gpio_pin_set(gpio0, LED_GREEN,0);
   gpio_pin_set(gpio0, LED_RED,0);
   k_timer_stop(&flasher);
}
void que_send_alert()
{
   uint32_t ret;
   uint8_t temp[50];
    

   gpio_pin_set(gpio0,LED_GREEN,0);                                   // turn off the green LED
   k_timer_stop(&flasher);
   FLASHER_MODE=1;                                                    // set the led RED-GREN sequence and timing
   k_timer_start(&flasher, K_MSEC(1000), K_MSEC(1000));               // and kick off the LEDs

   if(!QPOWEREDUP)                                                    // if the wuectel module isn't powere up
      {
         ret=quectel_powerup();                                       // go power it up
         if(ret!=0)                                                   // if power up failed
         {
            FLASHER_MODE=0;                                           // reset the flahing LEDs
            gpio_pin_set(gpio0, LED_GREEN,0);
            gpio_pin_set(gpio0, LED_RED,0);
            k_timer_stop(&flasher);                                  // stop the flasher
            if(!LOGGING)
                 logmsg_add(2,"ALERX PWRUP FAILED");
            return;
         }
      }


   qconnect();                                                        // quectel is powered up - connect to the server


   if(!QCONNECTED)                                                    // if there was a failure
   {
   
      
      bt_send_data("CONNECT FAILURE");                                // send a message
      if(!LOGGING)
           logmsg_add(2,"QUPDATE FAILURE 4");                              // log the failure
      quectel_powerdown();                                            // power dwn the chip
      FLASHER_MODE=0;                                                 // reset the flahing LEDs
      gpio_pin_set(gpio0, LED_GREEN,0);
      gpio_pin_set(gpio0, LED_RED,0);
      k_timer_stop(&flasher);
      if(!LOGGING)
         logmsg_add(2,"ALERX CONNECT FAILED");
      return;                                                         // and get out
  
   }
   memset(temp,0,sizeof(temp));
   strcpy(temp,"QPUBALERT ");                                          // build a QUB commnad to trigger the ALERT
   strcat(temp,&CMD[5]);                                              // with the text fromn the command inout
   strcpy(CMD,temp);                                                  // now copuy eveertthung back to CMD
   que_publish();   
   que_disconnect();                                                  // disconnect from the server
   quectel_powerdown();                                               // and powerdown the quectel chip
   FLASHER_MODE=0;                                                    // reset the flahing LEDs
   gpio_pin_set(gpio0, LED_GREEN,0);
   gpio_pin_set(gpio0, LED_RED,0);
   k_timer_stop(&flasher);
                                           //      vdd2 comes back down

}

void que_connect()     
{                                               // run the quectel connect scri
      uint8_t buffer[100];
      qconnect();
      if(!QCONNECTED)
      {
          if(!LOGGING)
             logmsg_add(2,"QCONNECT FAILED");
      }

}

void que_subscribe()                                                  // build the subscribe command
{
   uint8_t buffer[100],buffer2[100];
   memset(buffer,0,sizeof(buffer));
   memset(buffer2,0,sizeof(buffer2));
   strcpy(buffer,"AT+QMTSUB=2,1,");                                   // constant
   memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));                // isolate lockid as a null-terminated string
   strcat(buffer,"\"/");
   strcat(buffer,buffer2);
	strcat(buffer,"/confirm\",1");
   //bt_send_data(buffer);
	qmsgsend(buffer);

}

 void que_publish()
 {
   uint8_t buffer[200],buffer2[200],buffer3[200];
   memset(buffer,0,sizeof(buffer));
   memset(buffer2,0,sizeof(buffer2));
   memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));                // isolate lockid as a null-terminated string
   strcpy(buffer,"AT+QMTPUBEX=2,1,1,0,\"/");
   strcat(buffer,buffer2);
   strcat(buffer,"/activity\",");
   memset(buffer2,0,sizeof(buffer2));
   strcpy(buffer2,"\"");
   strcat(buffer2,&CMD[4]);
   strcat(buffer2,"\"");
   strcat(buffer,buffer2);
   strcpy(PATTERN,"confirm");                                                    // tell the message received thread what to look for
   PATTERNFOUND=false;                                                           //   and the PATTERNFOUND flag
   k_timer_start(&alarm,K_MSEC(20000),K_NO_WAIT);                                // set the alarm clock to 2 second
   
	qmsgsend(buffer);                                                             // and send the command to the Quectel module
	while((!ALARM)&&(!PATTERNFOUND))                                              // now wait for either the pattern to be recevied or the alarm to go off
	     {
             k_sleep(K_MSEC(50)); 
		  }
	if(ALARM) 
	   {                                                                          // if it went off
		    bt_send_data("confirm");                                               // inform the user
	   }
	k_timer_stop(&alarm);                                                          // disable the alarm     

  

 }

void que_disconnect()
 {
   uint8_t buffer[200];
   memset(buffer,0,sizeof(buffer));
   strcpy(buffer,"AT+QMTDISC=2");
   qmsgsend(buffer);
   QCONNECTED=false;
 }
 struct RTCDATE qget_date()
 {
 uint8_t buffer[100],buffer2[50];
 int32_t i;
  struct RTCDATE date;
  memset(&date,0,sizeof(date));                                                 // cleaf the date to NULLS
  if(!QCONNECTED)                                                              // if the quectel chip isn't connected to AWS
    {
          bt_send_data("NOT CONNECTED TO AWS");                                // notify the user
          return date;                                                         // and get out
    }
    memset(buffer,0,sizeof(buffer));                                           // clear the buffers to nulls
    memset(buffer2,0,sizeof(buffer2)); 
    memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));                        // isolate lockid as a null-terminated string
    strcpy(buffer,"AT+QMTPUBEX=2,1,1,0,\"/");                                  // and buid the PUBEX header
    strcat(buffer,buffer2);
    strcat(buffer,"/activity\",\"");
    strcat(buffer,"GETDATE\"");
    strcpy(PATTERN,"confirm");                                                 // tell the message received thread what to look for
    PATTERNFOUND=false;                                                        //   and reset the PATTERNFOUND flag
    ALARM=false;                                                               // turn off the ALARM
    bt_send_data(buffer);
    k_timer_start(&alarm,K_MSEC(4000),K_NO_WAIT);                              // set the alarm clock to 4 seconds
    qmsgsend(buffer);                                                          // and send the command to the Quectel module
	 while((!ALARM)&&(!PATTERNFOUND))                                           // now wait for either the pattern to be recevied or the alarm to go off
	   {
             k_sleep(K_MSEC(50)); 
      }
	 if(ALARM) 
	   {                                                                           // if it went off
		    bt_send_data("NO CONFIRM!");                                           // inform the user
          k_timer_stop(&alarm);                                                  // turn off the alarm clock
          return date;                                                                // and get out
	   }
   memset(buffer,0,sizeof(buffer));                                             // now - we convert the date sent back fron the server to the RTCDATE structure
   memmove(buffer,&PATTERNREC[37],4);                                            // get the year
   i=atoi(buffer);                                                               // convert it to an int
   date.year=i;
   memset(buffer,0,sizeof(buffer));                                             
   memmove(buffer,&PATTERNREC[41],2);                                            // get the month
   i=atoi(buffer);                                                               // convert it to an int
   date.month=i;   
   memset(buffer,0,sizeof(buffer));                                            
   memmove(buffer,&PATTERNREC[43],2);                                            // get the day
   i=atoi(buffer);                                                               // convert it to an int
   date.day=i;
   memset(buffer,0,sizeof(buffer));                                            
   memmove(buffer,&PATTERNREC[45],2);                                            // get the hour
   i=atoi(buffer);                                                               // convert it to an int
   date.hour=i;
   memset(buffer,0,sizeof(buffer));   
   memmove(buffer,&PATTERNREC[47],2);                                            // get the minute
   i=atoi(buffer);                                                               // convert it to an int
   date.minute=i;
   memset(buffer,0,sizeof(buffer));                                          
   memmove(buffer,&PATTERNREC[49],2);                                            // get the second
   i=atoi(buffer);                                                               // convert it to an int
   date.second=i;
   return date;                                                                  // and send tthe stucture back to the caller
 }

void que_post()                                                               // post activity to AWS server
{

 int32_t i,msgcnt[3],msgtot,pool;
 struct ACTREC actrec;
 struct RTCDATE date;
  struct LOGMSG *msg;
  uint8_t buffer[200],buffer2[200],buffer3[200],buffer4[200],buffer5[200];
  if(!QCONNECTED)                                                              // if the quectel chip isn't connected tto AWS
    {
          bt_send_data("NOT CONNECTED TO AWS");                                // notify the user
          return;                                                             // and get out
    }
   msgtot=0;                                                                  // clear the total message count
   for(i=0;i<3;i++)                                                           // go count all the stored activity
   {
      msgcnt[i]=msg_cnt(i);                                                   // retrieve the number of activity record
      msgtot+=msg_cnt(i);                                                     // in each message pool
   }
  if(msgtot==0)                                                               // if there are no records to upload
  {
          bt_send_data("NO ACTIVITY");                                        // notify the user
          return;                                                             // and get out
  }
  
  k_sem_give(&voltage_mon_on);                                                // start voltage monitoring

 for(pool=0;pool<3;pool++)                                                    // for each message pool
   {for(i=0;i<msgcnt[pool];i++)                                               // for each record in the pool
      {
          msg=retrieve_msg(pool, 0);                                          //      retrieve the record
         if(msg==NULL)                                                        // if there s no data(we should never see this)
            {bt_send_data("NO MESGS");                                        // infor the user and 
            continue;                                                         //    go to the next pool
            }
         memset(buffer,0,sizeof(buffer));                                     // clear all the buffers
         memset(buffer2,0,sizeof(buffer2));
         memset(buffer3,0,sizeof(buffer3));
         memset(buffer4,0,sizeof(buffer4));
         memset(buffer5,0,sizeof(buffer5));
  
         strcpy(buffer,"AT+QMTPUBEX=2,1,1,0,\"/");                            // and buid the PUBEX header
         memset(buffer2,0,sizeof(buffer2));                              // the lock number
         memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));              // isolate lockid as a null-terminated string
         strcat(buffer,buffer2);
         strcat(buffer,"/activity\",");
         if(pool==0)                                                          // if this is a  boot record
         { 

             strcpy(buffer4,"\"");                                            // set up the beginning of buffer4 - which will contain the decoded actvity record
             strcat(buffer4,"LOCKBOOT ");                                     // the LOCKBOOT tag
             memset(buffer2,0,sizeof(buffer2));                              // the lock number
             memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));              // isolate lockid as a null-terminated string
             strcat(buffer4,buffer2);    
             strcat(buffer4," ");                                             // a space
             date=dt_to_disp(msg->date);                                      // convert the date to display format
             sprintf(buffer3,"%02d/%02d/%04d %02d:%02d:%02d",                 // format the date to display format
                date.month, date.day, date.year, date.hour, date.minute, date.second);
             strcat(buffer4,buffer3);                                         // add it to the record
             strcat(buffer4," ");                                             // add a space
             strcat(buffer4,msg->data);                                       // add the message text
             strcat(buffer4,"\"");                                            // and the trailing double quote
             strcat(buffer,buffer4);                                          // and finally, add all of ths to the PUBEX command
         }
         if(pool==1)                                                          // if this is an acctivity record
         {  
             memset(buffer2,0,sizeof(buffer2));
             strcpy(buffer4,"\"");                                            // set up the beginning of buffer4 - which will contain the decoded actvity record
             strcat(buffer4,"LOCKDATA ");
             memcpy(&actrec,msg,32);                                          // put the recrd in the template
             memcpy(buffer2,actrec.cmd,7);                                    // retrieve the cmommand
             strcat(buffer4, buffer2);                                        // and append it to buffer4
             strcat(buffer4," ");                                             // append a space
             date=dt_to_disp(actrec.date);                                    // convert the date to display format
             sprintf(buffer2,"%02d/%02d/%04d %02d:%02d:%02d",                 // format the beginning of the record
                date.month, date.day, date.year, date.hour, date.minute, date.second);
             sprintf(buffer3," %d %d %d %d %d %d %d",                         // format the balance of the record
                 actrec.command,actrec.srce,actrec.phase,actrec.err,actrec.temp,actrec.v1,actrec.v2);
             strcat(buffer2,buffer3);                                         // put both toogether
             strcat(buffer4,buffer2);                                         //and append them to buffer4
             memset(buffer2,0,sizeof(buffer2));                               // clear buffer2
             memmove(buffer2,PARMS.FWVERSION,sizeof(PARMS.FWVERSION));        // isolate firmaware revision as a null-terminated string
             strcat(buffer4," ");                                             // put a space at the end of buffer
             strcat(buffer4, buffer2);                                        // and append the firmware version
             strcat(buffer4,"\"");                                            // add the terminating double-quote
             strcat(buffer,buffer4);  
         }   
         if(pool==2)                                                          // if this is an EVENT record
         {
             memset(buffer2,0,sizeof(buffer2));
             strcpy(buffer4,"\"");                                            // set up the beginning of buffer4 - which will contain the decoded actvity record
             strcat(buffer4,"LOCKEVENT ");                                    // the LOCKEVENT tag
             memset(buffer2,0,sizeof(buffer2));                              // the lock number
             memmove(buffer2,PARMS.lockid,sizeof(PARMS.lockid));              // isolate lockid as a null-terminated string
             strcat(buffer4,buffer2);                                         // the lockbox number
             strcat(buffer4," ");                                             // a space
             date=dt_to_disp(msg->date);                                      // convert the date to display format
             sprintf(buffer3,"%02d/%02d/%04d %02d:%02d:%02d",                 // format the date to display format
                date.month, date.day, date.year, date.hour, date.minute, date.second);
             strcat(buffer4,buffer3);                                         // add it to the record
             strcat(buffer4," ");                                             // add a space
             strcat(buffer4,msg->data);                                       // add the message text
             strcat(buffer4,"\"");                                            // and the trailing double quote
             strcat(buffer,buffer4);                                          // and finally, add all of ths to the PUBEX command
         }                                                                    // and assemble the entire mesag
      
      strcpy(PATTERN,"confirm");                                              // tell the message received thread what to look for
      ALARM=false;                                                            // turn off the ALARM
      PATTERNFOUND=false;                                                     //   and reset the PATTERNFOUND flag
      k_timer_start(&alarm,K_MSEC(10000),K_NO_WAIT);                           // set the alarm clock to 4 seconds
      NO_BT_DISP=true;
	   qmsgsend(buffer);                                                       // and send the command to the Quectel module
	   while((!ALARM)&&(!PATTERNFOUND))                                        // now wait for either the pattern to be recevied or the alarm to go off
	   {
             k_sleep(K_MSEC(50)); 
      }
	   if(ALARM) 
	   {                                                                          // if it went off
		    bt_send_data("NO CONFIRM!");                                               // inform the user
           if(!LOGGING)
               logmsg_add(2,"ACT POST FAILED");                                  // log the failure
          i--;                                                                   // move the message pointer back one history record
          break;                                                                 // and leaave to post history loop
   
	   }
      bt_send_data("OK - SENT");
	   k_timer_stop(&alarm);   
      logmsg_del(pool);                                                         // delete the record that was just uploaded
	   
     }

   }
   k_sem_give(&voltage_mon_off);                                                // stop monitoring the voltage
    NO_BT_DISP=false;
   sprintf(buffer,"LOW VOLTAGE %d CNT %d",LOW_VOLTAGE, LVCNT);                    // and report            
   bt_send_data(buffer); 


}


void clear_aws_partition(int part)                                            // cllear an AWS partition
{uint32_t address;
 uint32_t i;
 uint8_t buffer[128];
 uint32_t nextpart;
 i=part*2-1;                                                                  // calculate tthe MAP.Aadresssllot for thee partition
 if(i==1)                                                                     // now set the address of the next partition
    nextpart=MAP.addr[3];
 if(i==3)
    nextpart=MAP.addr[5];
 if(i==5)
    nextpart=MAP.addr[7];
if(i==7)
    nextpart=MAP.addr[11];
 address=MAP.addr[i];
 memset(buffer,0,sizeof(buffer));                                             // set up a 128 byte chunk of nULLS
 while(address<nextpart)                                                      //    and clear the partition to nulls
    {
      eeprom_store(address,sizeof(buffer),(void *) buffer);
      address+=sizeof(buffer);
    }
 }

void edit_aws_params()
{
   uint32_t i,j,semipos;
   bool semisw = false;
   AWSSIZE=0;
   AWSCKSUM=0;
   AWSTYPE=0;
   i=strlen(AWSPARAMS);
   for(j=0;j<(i-1);j++)                                                      // scan the oarameters
   {
      if(isdigit(AWSPARAMS[j]))                                              // digits are allowed
           continue; 
      if(AWSPARAMS[j]== ';')                                                 // as is a single sememicolon           
      {
         if(!semisw)
         {
            semisw=true;                                                     // if gthis is thee first p set the switch
            semipos=j;                                                       // save the position
            continue;                                                        // and continue
         }
       bt_send_data("ERR 1");                                                // flag the error
       return;                                                               // and get out
      }  
      bt_send_data("ERR 1");                                                 // icf it's not a semicolon - er reject it
      return;         
   }
   if(!semisw)
   {
      bt_send_data("ERR 1");                                                 // if we didn't get a semicolon - we reject it
      return;
   }
   AWSSIZE=atoi(AWSPARAMS);                                                  // otherwise we save the size and chechsum
   AWSCKSUM=atoi(&AWSPARAMS[semipos+1]);

}

void endp_load()                                                              // the followinf eight routines load and check
{                                                                             //      the AWS certificates, keys and endpoint
   bt_send_data("DERECATED");                                                         // they are here for testing onlg - in production this data will
}                                                                             // in all likelyhood be sent directly over the blue tooth connetion

void endp_chk()
{ 
    uint8_t msg[30];
   uint32_t cksum;
   cksum=chk_cert(3);
   sprintf(msg,"CKSUM is %d",cksum);
   bt_send_data(msg);
}
void cacert_build()                                                           // oad the AWS cefrtificate over bluetooth
{
   uint8_t buff[60];
   strcpy(AWSPARAMS,&CMD[7]);                                                 // load the paraameters into a work area
   edit_aws_params();                                                         // and go edit them
   if(AWSSIZE==0)
       return;
   sprintf(buff,"SZ=%d SUM = %d",AWSSIZE,AWSCKSUM);                           // debug onky - reeove gthe sprintf and bt_send_data() for production
   bt_send_data(buff);
   AWSTYPE=1;                                                                 // and set up to recrove chunks
   MAP.addr[2]=AWSSIZE;                                                       // store the size
   eeprom_store(0,sizeof(MAP),(void *)&MAP);                                  // and store the EEPROM MAP at the beginning of the EEPROM
   clear_aws_partition(AWSTYPE);                                              // go clear the partition
   bt_send_data("OK");
   AWSLOADING=true;
}

void clicert_build()                                                       // load the client cefrtificate over bluetooth
{
   uint8_t buff[60];
   strcpy(AWSPARAMS,&CMD[8]);                                                 // load the paraameters into a work area
   edit_aws_params();                                                         // and go edit them
   if(AWSSIZE==0)
       return;
   sprintf(buff,"SZ=%d SUM = %d",AWSSIZE,AWSCKSUM);                           // debug onky - reeove gthe sprintf and bt_send_data() for production
   bt_send_data(buff);
   AWSTYPE=2;                                                                 // and set up to recrove cliceert chunks
   MAP.addr[4]=AWSSIZE;                                                       // store the size
   eeprom_store(0,sizeof(MAP),(void *)&MAP);                                  // and store the EEPROM MAP at the beginning of the EEPROM
   clear_aws_partition(AWSTYPE);                                              // go clear the partition
   //(2,"LOADING CLI CERT");
   bt_send_data("OK");
   AWSLOADING=true;
}


void clikey_build()                                                           // oad the client cefrtificate over bluetooth
{
   uint8_t buff[60];
   strcpy(AWSPARAMS,&CMD[8]);                                                 // load the paraameters into a work area
   edit_aws_params();                                                         // and go edit them
   if(AWSSIZE==0)
       return;
   sprintf(buff,"SZ=%d SUM = %d",AWSSIZE,AWSCKSUM);                           // debug onky - reeove gthe sprintf and bt_send_data() for production
   bt_send_data(buff);
   AWSTYPE=3;                                                                 // and set up to recrove cakey chunks
     MAP.addr[6]=AWSSIZE;                                                       // store the size
   eeprom_store(0,sizeof(MAP),(void *)&MAP);                                  // and store the EEPROM MAP at the beginning of the EEPROM
   clear_aws_partition(AWSTYPE);                                              // go clear the partition
   bt_send_data("OK");
   AWSLOADING=true;

}


void endp_build()                                                             // load the AWS endpoint over bluetooth
{
   uint8_t buff[60];
   strcpy(AWSPARAMS,&CMD[9]);                                                 // load the paraameters into a work area
   edit_aws_params();                                                         // and go edit them
   if(AWSSIZE==0)
       return;
   sprintf(buff,"SZ=%d SUM = %d",AWSSIZE,AWSCKSUM);                           // debug onky - reeove gthe sprintf and bt_send_data() for production
   bt_send_data(buff);
   AWSTYPE=4;                                                                 // set up to recrove endpoint  chunks
   MAP.addr[8]=AWSSIZE;                                                       // store the size
   eeprom_store(0,sizeof(MAP),(void *)&MAP);                                  // and store the EEPROM MAP at the beginning of the EEPROM
   clear_aws_partition(AWSTYPE);                                              // go clear the partition
   bt_send_data("OK");
   AWSLOADING=true;;
}
   
void process_chunk()                                                          // process AWS chunks
{  uint32_t chunknbr,chunksize;
   uint32_t address;
   uint8_t buff[100];
   uint32_t i,j;

   if(AWSTYPE==0)                                                             // Iif we aren't loading aws data loading AWS data
   {    
      bt_send_data("ERR 1");                                                 // sedn an arror message
      return;
   }

    if(CMD[8]!=';')                                                           // there must be a semicolon at position 8
   {
      bt_send_data("ERR 2");
      return;

   }  

   address=MAP.addr[AWSTYPE*2-1];                                             // this is the base address of the data -
   chunknbr=atoi(&CMD[5]);
   chunksize=strlen(CMD)-10;
   i=chunknbr%2;
   if(i==0)
       gpio_pin_set(gpio0,LED_RED,0);
   else gpio_pin_set(gpio0,LED_RED,1);
   sprintf(buff,"NBR=%d SIZE=%d",chunknbr,chunksize);
   i=address+chunknbr*64;                                                     // the eeprom address for this chunk
   eeprom_store(i,chunksize,(void *)&CMD[9]);                                 // go store it
   bt_send_data(buff);
   AWSSIZE=AWSSIZE-chunksize;                                                 // keep track of how much we've loaded so far
   if(AWSSIZE==0)                                                             // if we've loaded everything
      {
       AWSLOADING=false;
       AWSTYPE=0;
      }                                         


}
void cacert_load()
{
   bt_send_data("DERECATED");
}
void cacert_chk()
{
 
   uint8_t msg[30];
   uint32_t cksum;
   cksum=chk_cert(0);
   sprintf(msg,"CKSUM is %d",cksum);
   bt_send_data(msg);
}
void clicert_load()
{
   bt_send_data("DEPRECATED");
}
void certs_dump()
{
   uint32_t i;
   for(i=0;i<4;i++)
       dump_cert(i);

}
void clicert_chk()
{

   uint8_t msg[30];
   uint32_t cksum;
   cksum=chk_cert(1);
   sprintf(msg,"CKSUM is %d",cksum);
   bt_send_data(msg);
}
void clikey_load()
{
   bt_send_data("DEPRECATED");
}
void clikey_chk()
{
 
   uint8_t msg[30];
   uint32_t cksum;
   cksum=chk_cert(2);
   sprintf(msg,"CKSUM is %d",cksum);
   bt_send_data(msg);
}

void erase_eeprom()                                                            // erase eeprom clears the eeprom signature to nulls
{  uint8_t buffer[128];                                                        // on the next boot of the chip the eeprom map will be reinitilaized
   uint32_t  i;                                                                // and all of the eeprom controls will be reinitiialaized
   for(i=0;i<sizeof(buffer);i++)
        buffer[i]=0;
   eeprom_store(SIG_ADDRESS,SIG_SIZE,buffer);
   bt_send_data("EEPROM INITIALIZED");
   k_sleep(K_MSEC(1000));
   sys_reboot(SYS_REBOOT_COLD);                                                 // now - reboot the chip - on reboot the balance of
                                                                                // the eepro0m willbe initialized
}
void msgs_add()
{ uint32_t i,J;
  i=strlen(CMD);                                                                 // eliminate the trailing comma
  CMD[i-1]=0;
  i=CMD[6]-48;                                                                   // get the message pool number
J=strlen(CMD);
if(J>28)
{
   bt_send_data("MESSAGE TOO LONG");
   return;
}
   if(!LOGGING)
    logmsg_add(2, &CMD[6]);                                                        // add the text tro the error log
  bt_send_data("ADDED");
}
void msgs_list()
{
 uint32_t i,msgcnt,p;
 struct ACTREC actrec;
 struct RTCDATE date;
  struct LOGMSG *msg;
  uint8_t buffer[90],buffer2[90],buffer3[90];
 p=CMD[6]-48;
 if((p!=0)&&(p!=1)&&(p!=2))
     {
      bt_send_data("POOL M/B 0 1 OR 2");
      return;
    }
 
msgcnt=msg_cnt(p);



 for(i=0;i<msgcnt;i++)
   { msg=retrieve_msg(p, i);
     if(msg==NULL)
        {bt_send_data("NO MESSAGE");
        break;
        }
      msg=retrieve_msg(p,i);
      date=dt_to_disp(msg->date);
      if(p!=1)
          {sprintf(buffer,"%02d/%02d/%04d %02d:%02d:%02d %s", 
               date.month,date.day,date.year,date.hour,date.minute,date.second,msg->data);
          }
      else {
             memcpy(&actrec,msg,32);
             date=dt_to_disp(actrec.date);                                                 // convert the date to display format
             sprintf(buffer,"%02d/%02d/%04d %02d:%02d:%02d",                               //format the beginning of the record
                  date.month, date.day, date.year, date.hour, date.minute, date.second);
             memset(buffer3,0,sizeof(buffer3));                                            // set up
             memcpy(buffer3,actrec.cmd,7);                                                 // extract
             sprintf(buffer2," %s",buffer3);                                               // format
             strcat(buffer,buffer2);                                                       //and append the command to the record
             sprintf(buffer2," %d %d %d %d %d %d %d %s",                                         // format the balance of the record
                  actrec.command,actrec.srce,actrec.phase,actrec.err,actrec.temp,actrec.v1,actrec.v2,PARMS.FWVERSION);
             strcat(buffer,buffer2);    
           }

      
      bt_send_data(buffer);
      //k_sleep(K_MSEC(100));
   }
 bt_send_data("END");
 
}

void msgs_del()
{
   uint32_t i;
   i=CMD[6]-48;                                                           // calculate the message pool address
   if((i!=0)&&(i!=1)&&(i!=2))                                             // make sure we're pointed at a good poolpool
      {
       bt_send_data("POOL M/B 0 1 OR 2");
       return;
      }
   i=logmsg_del(i);


}
void get_temp()
{uint32_t temp;
 uint8_t buffer[50];


 sprintf(buffer,"TEMP IS %d F",temp);
 bt_send_data(buffer);
}
void read_eeprom()
{uint8_t buffer[50], buffer2[200],buffer3[50];
 uint32_t i;

  if(EEPROM_SIZE==0)
    {bt_send_data("SET EEPROM_SIZE");
     return;
    }
  if(EEPROM_SIZE>32)
    {bt_send_data("READ 32 BYTES MAX");
     return;
    }
 eeprom_retrieve(EEPROM_ADDR,EEPROM_SIZE,buffer);
 memset(buffer2,0,sizeof(buffer2));
 for(i=0;i<EEPROM_SIZE;i++)
    {sprintf(buffer3,"%02X,", buffer[i]);
     strcat(buffer2,buffer3);
    }
 bt_send_data(buffer2); 
}
void test_eeprom()
{uint8_t buffer[300], buffer2[300], buffer3[30];
 uint32_t i;
 for(i=0;i<300;i++)
    buffer[i]=i;
 if(EEPROM_SIZE==0)
    {bt_send_data("SET EEPROM_SIZE");
     return;
    }
 eeprom_store(EEPROM_ADDR,EEPROM_SIZE, buffer);
 memset(buffer2,0,sizeof(buffer2));
 eeprom_retrieve(EEPROM_ADDR,EEPROM_SIZE,buffer2);
 for(i=0;i<EEPROM_SIZE;i++)
   if(buffer[i]!=buffer2[i])
      {sprintf(buffer3,"ERROR AT BYTE %d",i);
       bt_send_data(buffer3);
       return;
      }
 sprintf(buffer3,"%d WRITTEN AND READ",EEPROM_SIZE);
  bt_send_data(buffer3);
}

void set_eeprom_addr()
{uint32_t i;
 uint8_t buffer[100];
 i=atoi(&CMD[7]);
 if(i>65535)
   {bt_send_data("IVALID ADDRESS");
    return;
   }
 EEPROM_ADDR=i;
 sprintf(buffer,"ADDR IS %d",EEPROM_ADDR);
 bt_send_data(buffer);
}

void set_eeprom_size()
{
 uint32_t i;
 uint8_t buffer[100];
 i=atoi(&CMD[7]);
 if((i<1)||(i>300))
   {bt_send_data("IVALID SIZE");
    return;
   }
 EEPROM_SIZE=i;
 sprintf(buffer,"SIZE IS %d",EEPROM_SIZE);
 bt_send_data(buffer);
}
void set_speed()
{
   bt_send_data("DEPRECATED");
}
void set_delay()
{
   bt_send_data("DEPRECATED");
}
void set_mod()
{
   bt_send_data("DEPRECATED");
}
void set_sub()
{
   bt_send_data("DEPRECATED");
}


void set_msg_on()
{
 gpio_pin_set(gpio0,VDD5_ENABLE,1);

 bt_send_data("VDD5 shoud be up");
 return;

}
void set_msg_off()
{
gpio_pin_set(gpio0,VDD5_ENABLE,0);

 bt_send_data("VDD5 shoud be down");
 return;

}
void set_mode()
{
 bt_send_data("NOT IMPLEMENTED");
 //rfid_test();
 return;
}
void report_rf()
{uint8_t buff[50];
 bt_send_data("NOT IMPLEMENTED");
 return;
 
}
void stop_rf()
{
 bt_send_data("NOT IMPLEMENTED");
 return;

}
void start_rf()
{
 bt_send_data("NOT IMPLEMENTED");
 return;

}
void run_rf()
{
 bt_send_data("NOT IMPLEMENTED");
 return;

}
void set_alert_timeout()
{
   uint32_t i;
   uint8_t buffer[100];
   bt_send_data(CMD);
   i=atoi(&CMD[8]);
   if((i<30)||(i>10600))
     {
      sprintf(buffer,"TIMEOUT=%d",i);
      bt_send_data(buffer);
      bt_send_data("INVALID SIZE");
      return;
     }
   PARMS.TIMEOUTDELAY=i;
   sprintf(buffer,"ALERT TIMEOUT IS %d SECONDS",PARMS.TIMEOUTDELAY);
   bt_send_data(buffer);
   TIMEOUTDELAY=PARMS.TIMEOUTDELAY;
   eeprom_update_parms();
}
void rf_test()
{
   uint32_t ret,mode,i,j;
   uint8_t buffer[50];
   i=strlen(CMD);                                                          // edit the command
   if(i!=8)                                                                // m/b exactly 8 bytes
   {
      bt_send_data("ERR 1");
      return;
   }
   mode=CMD[6]-48;                                                         // and must be either RFTEST0 or RFTEST1
   if((mode!=0)&&(mode!=1))
   {
      bt_send_data("ERR 2");
      return;
   }
   k_sem_give(&voltage_mon_on);                                            // start voltage monitoring     

   k_sem_give(&voltage_mon_off);                                            // stop monitoring the voltage
   sprintf(buffer,"LOW VOLTAGE %d CNT %d",LOW_VOLTAGE, LVCNT);             //  format the voltage message
   bt_send_data(buffer);                                                   // and send it off
   if(mode==0)                                                             // if we were just testing the chip
   {
      if(j==0)                                                             // and the test passed
          bt_send_data("OK");
      else bt_send_data("FAIL");
      return;
   }
   if(j==0)
   {
      memset(buffer,0,sizeof(buffer));
      strcpy(buffer,"FOUND TAG ");
      strcat(buffer,RFIDTAGID);
      bt_send_data(buffer);
   }

   else bt_send_data("NO TAG");

   return;

}
void fix_anchors()
{
   int32_t i;
   struct EEPROMMSGS MSG;
   MAP.addr[0]=SIG_ADDRESS;                                              // initialize the EEPROM MAP - 0 is the SIGNATURE ADDRESS
   MAP.addr[1]=1024;                                                     // this is the cacert address in EEPROM
   MAP.addr[2]=0;                                                        // this is the actual length of the cacert - filled in when the certr is loaded
   MAP.addr[3]=4096;                                                     // this is the clicert address in EEPROM
   MAP.addr[4]=0;                                                        // this is the actual length of the clicert - filled in when the 
   MAP.addr[5]=7168;                                                     // this is the address of the clikey in EEPROM
   MAP.addr[6]=0;                                                        // this is the actual length of the clikey  - filled in whenthe key is loaded
   MAP.addr[7]=10240;                                                    // this is the AWS IOT endpoint address in EEPROM
   MAP.addr[8]=0;                                                        // this is the length of the AWS IOT endpiont - filled in when the endpoint is loaded
   MAP.addr[9]=128;                                                      // the PARAMS address
   MAP.addr[10]=46720;                                                   // this is the beginning of the LOGFILE  - there is room for 566 32 byte records  plus the section EEPROMMSGS map
   MAP.addr[11]=10368;                                                   // this is the beginning of the  ACTIVITY FILE - there us room for 566 32 byte records plus the section EEPROMMSGS map
   MAP.addr[12]=28544;                                                   // this is the beginning of the EERROR FILE - there is room for 566 32 byte records 1 plus the section EEPROMMSGS map
   eeprom_store(0,sizeof(MAP),(void *)&MAP);                             // store the EEPROM MAP at the beginning of the EEPROM
   for(i=10;i<13;i++)                                                    // now - built the LOG, ACTIVITY and ERROR file EEPROMMSGS blocks
   {
      MSG.fstmsg=9999;
      MSG.lstmsg=9999;
      MSG.msgcnt=0;
      if(i==10)
            MSG.availcnt=566;
      if(i==11)
          MSG.availcnt=566;
      if(i==12)
          MSG.availcnt=566;
          
      eeprom_store(MAP.addr[i],sizeof(MSG),(void *)&MSG);
      bt_send_data("CRAP");
   }
   eeprom_retrieve(0,sizeof(MAP),&MAP);                            // now -load the eeprom map
}
void set_rgain()
{
   bt_send_data("DEPRECATED");
}
void set_lmi()
{
   bt_send_data("DEPRECATED");
}
void set_tmr()
{
   bt_send_data("DEPRECATED");
}

void proc_cmd(void)
{uint8_t *cmds[]={
    // 00   01    02        03       04       05       06     07     08    09     10       11        12
     "CMD","XMD","DATEDSP","SETLMI","SETRGN","SETTMR","STOP","STEP","REP","MODE","TRAFON","TRAFOFF","GO",
    // 13       14     15        16         17       18        19      20       21       22
     "ROMTEST","TEMP","ROMADDR","ROMSIZE","ROMREAD","SETSPD","SETDEL","SETMOD","SETSUB","MSGLST",
    // 23      24       25       26      27        28       29        30        31       32
     "MSGADD","MSGDEL","CALOAD","CACHK","CLILOAD","CLICHK","KEYLOAD","KEYCHK","ENDLOAD","ENDCHK",
    // 33        34    35      36       37        38      39      40     41    42   43    44     45        46        47  
     "ROMINIT","QCOM","RESET","FRCERR","KEYPADE","SOUND","RATIO","CNTR","CCW","CW","VOL","BEEP","DATESET","BATTDSP","NUDG",
    // 48       49        50         51      52         53        54        55       56        57        58
     "COMMBOX","DATECHK","DATEHST","ADVSET","KPERRSET","KPTOSET","IDLESET","PARAMS","BATTHST","VERSION","TESTLED",
    // 59       60     61       62         63         64          65      66       67      68        69       70
     "ANCHORS","BHC","CABUILD","CLIBUILD","KEYBUILD","ENDPBUILD","CHUNK","RFTEST","QPWRUP","QPWRDN","SWTEST","LVLSET",
    // 71      72      73       74        75         76         77      78       79         80     81     82 
     "SNDSET","RFSET","KBDTST","ASSYTST","DOORTEST","HASPTEST","QSTAT","QCRTLD","QCONNECT","QSUB","QPUB","QDISC",
    // 83        84         85       86     87       88       89      90      91       92        93        94
     "DATEADJ","DUMPCERTS","SETTZ","QPOST","SCRIPT","MOTORSET","VDUMP","QDATE","AWSSET","QUPDATE","IMEISET","IMEILD",
    // 95      96       97         98          99
     "CENTTST","ALERT","ALARMSET","FIXANCHORS","QGETFW","END"};
 int i,j,k,cmdct=0;
 uint8_t buffer[200];
 bool vdd2_is_up;

 k_sem_take(&ble_init_ok, K_FOREVER);

                                                                // we bring it up (and taje it down when we're done with whatever)
 for(;;)
     {
        

      struct cmd_data_t *buf= k_fifo_get(&fifo_cmd_data,                            // wait for a commnd from either bt_receive or keypad input
						     K_FOREVER);
   
      PROCRUNNING=true;
      vdd2_is_up=VDD2_UP;                                                               // proc cme will bring up VDD2
      if(!vdd2_is_up)                                                                   // so if it isn't up
           vdd2_up();      
      memset(CMD,0,CMDSIZE);                                                              // clear the COMMND WORK AREA
      memmove(CMD,buf->data,buf->len);  
                                             // and move the command into it
      k_free(buf);
      cmdct++;
      //if(cmdct>1)
      //   printk("HERE");
      j=strlen(CMD);                                                                  // Get the command stringlength
                                                         // this accomplishes the same thing
      i=0;
      sprintf(buffer,"GOT %s",CMD);
      //bt_send_data(buffer);
      while(true)                                                                     // now - search for the command
        {j=strcmp(cmds[i],"END");                                                    // if we'e reached the end of the table
         if(j==0)
             break;
            
         j=strncmp(CMD,cmds[i],strlen(cmds[i]));                                    // Check to see if this is the command
         if(j==0)                                                                   // if it is, get out
            break;
         i++;                                                                       // otherwise, try again
        }
      if(AWSLOADING)                                                                // if we are  loading AWS certificate and endpoint data
          if(i!=65)                                                                 //  and this is not a chunk command
              { if(!LOGGING)
                   logmsg_add(2,"LOAD FAILED");                                         //    the load must have failed
               AWSLOADING=false;
               AWSTYPE=0;
               AWSSIZE=0;
              }
      k=atoi(&PARMS.lockid[2]);                                     // lock number ZB00000001
/*
     if((i>2)&&(!SUPERUSERMODE)&&(k>10)&&(!TESTING))
     {
         bt_send_data("NOT ALLOWED");
    
     }
     else */ switch(i)
        {      
          case 0:
          lockcmd();
          if(RUN_CHECK_SWS)
          {
           bt_send_data("STARTING CK SWS");
           k_timer_start(&check_sws, K_MSEC(500), K_MSEC(500));                             // start the timer that checks the switches
           RUN_CHECK_SWS=false;                                                             // and turn off the logical
          }
          if(RUN_SPOOF)
          {
           bt_send_data("STARTING SPOOF");
           k_timer_start                                                                    // start the 'spoof imer
                   (&spoof, K_MSEC(2000), K_MSEC(2000));
           RUN_SPOOF=false;                                                             // and turn off the logical
          }
          break;

          case 1:
          lockcmd();
          if(RUN_CHECK_SWS)
          {
           bt_send_data("STARTING CK SWS");
           k_timer_start(&check_sws, K_MSEC(500), K_MSEC(500));                             // start the timer that checks the switches
           RUN_CHECK_SWS=false;                                                             // and turn off the logical
          }
          if(RUN_SPOOF)
          {
            bt_send_data("STARTING SPOOF");
            k_timer_start                                                                    // start the 'spoof imer
                    (&spoof, K_MSEC(2000), K_MSEC(2000));
            RUN_SPOOF=false;                                                             // and turn off the logical
           }
          break;

          case 2:
          get_date();  
          break;                                                                

          case 3:
          set_lmi();
          break;

          case 4:
          set_rgain();
          break;

          case 5:
          set_tmr();
          break;

          case 6:
          stop_rf();
          break;

          case 7:
          start_rf();
          break;

          case 8:
          report_rf();
          break;

          case 9:
          set_mode(); 
          break;

          case 10:
          set_msg_on();
          break;

          case 11:
          set_msg_off();
          break;

          case 12:
          run_rf();
          break;

          case 13:
          test_eeprom();
          break;

          case 14:
          get_temp();
          break;

          case 15:
          set_eeprom_addr();
          break;

          case 16:
          set_eeprom_size();
          break;

          case 17:
          read_eeprom();
          break;

          case 18:
          set_speed();
          break;

          case 19:
          set_delay();
          break;

          case 20:
          set_mod();
          break;

          case 21:
          set_sub();
          break;

          case 22:
          msgs_list();
          break;

          case 23:
          msgs_add();
          break;

          case 24:
          msgs_del();
          break;

          case 25:
          cacert_load();
          break;
      
          case 26:
          cacert_chk();
          break;

          case 27:
          clicert_load();
          break;
      
          case 28:
          clicert_chk();
          break;

          case 29:
          clikey_load();
          break;
      
          case 30:
          clikey_chk();
          break;

          case 31:
          endp_load();
          break;

          case 32:
          endp_chk();
          break;

          case 33:
          erase_eeprom();
          break;

          case 34:
          que_comm();
          break;

          case 35:
          sys_reboot(SYS_REBOOT_COLD); 
          break;

          case 36:
          force_error();
          break;

          case 37:
          echo_keypad();

          break;

          case 38:
          play_sound_samples();
          break;

          case 39:
          set_ratio();
          break;

          case 40:
          center_motor();
          break;

         case 41:
         motor_ccw();
         break;

         case 42:
         motor_cw();
         break;


         case 43:
         sound_set_vol();
         break;

         case 44:
         sound_beep();
         break;


         case 45:
         date_set();
         break;

         case 46:
         get_batt();
         break;

         case 47:
         motor_nudge();
         break;  

         case 48:
         commission_lockbox();
         break;

         case 49:
         date_check();
         break;

         case 50:
         date_hist();
         break;

         case 51:
         params_set_ai();
         break;

         case 52:
         params_set_klim();
         break;

         case 53:
         params_set_kto();
         break;

         case 54:
         params_set_ito();
         break;

         case 55:
         params_disp();
         break;

         case 56:
         battery_disp();
         break;

         case 57:
         display_firmware();
         break;

         case 58:
         test_led();
         break;

         case 59:
         display_anchors();
         break;

         case 60:
         create_batt_hist();
         break;

         case 61:
         cacert_build();
         break;
         
         case 62:
         clicert_build();
         break;

         case 63:
         clikey_build();
         break;

         case 64:
         endp_build();
         break;

         case 65:
         process_chunk();
         break;

         case 66:
         rf_test();
         break;

         case 67:
         quec_up();
         break;

         case 68:
         quec_down();
         break;

         case 69:
         test_sws();
         break;

         case 70:
         params_set_lowvoltage();
         break;

         case 71:
         params_set_sound();
         break;

         case 72:
         params_set_rfid();
         break;
         
         case 73:
         kbdtest();
         break;

         case 74:
         setassy();
         break;
         
         case 75:
         doortest();
         break;

         case 76:
         hasptest();
         break;

         case 77:
         que_stat();
         break;

         case 78:
         que_certld();
         break;

         case 79:
         que_connect();
         break;

         case 80:
         que_subscribe();
         break;

         case 81:
         que_publish();
         break;

         case 82:
         que_disconnect();
         break;

         case 83:
         date_adj();
         break;

         case 84:
         certs_dump();
         break;

         case 85:
         set_timezone();
         break;

         case 86:
         que_post();
         break; 

         case 87:
         script();
         break;
         
         case 88:
         set_motor() ;
        break;

         case 89:
         dump_voltages();
         break;

         case 90:
         qget_date();
         break;

         case 91:
         params_set_aws();
         break;
         
         case 92:
         que_update();
         break;

         case 93:
         set_imei();
         break;

         case 94:
         load_imei();
         break;

         case 95:
         check_center();
         break;

         case 96:
         que_send_alert();
         break;


         case 97:
         set_alert_timeout();
         break;

         case 98:
         fix_anchors();
         break;

         case 99:
         qget_firmware();
         break;

         default:
         bt_send_data("INVALID COMMAND");
         break;

        }
       PROCRUNNING=false;
       if(!vdd2_is_up)                                                                 // if proc_cmd broutht vdd2 up
         vdd2_down();                                                                  // we bring it down here
     }
     if(RUN_CHECK_SWS)
     {
      bt_send_data("STARTING CK SWS");
      k_timer_start(&check_sws, K_MSEC(500), K_MSEC(500));                             // start the timer that checks the switches
      RUN_CHECK_SWS=false;                                                             // and turn off the logical
     }


}

K_THREAD_DEFINE(proc_cmd_id, STACKSIZE, proc_cmd, NULL, NULL,
		NULL, PRIORITY, 0, 0);
